{-------------------------------------------------------------}
{
{             Cartavox - Rotinas de envio de carta
{
{-------------------------------------------------------------}

unit carEnvia;

interface

uses
    dvArq,
    dvCrt,
    dvForm,
    dvHora,
    dvWin,
    sysutils,
    windows,
    carApeli,
    carCC,
    carDecod,
    carEst,
    carLeit,
    carMsg,
    carSMTP,
    carTela,
    carUtil,
    carVars,
    carList,
    carResp;

    function preencheArqResposta (nCar: integer; perguntaSeAssina: boolean; encaminha: boolean; var nomeArq: string): boolean;
    procedure prepararCarta (tipo: char; nCar: integer; editaPreparada: boolean; nomeDest: string);
    function escolheNomeArq (var editar: boolean): string;
    procedure prepararCartaRespAut (quantCartas: integer; vaiEnviar: boolean);

var
    dirAtual: string;
    confReceb : boolean;

implementation

{-------------------------------------------------------------}
{       Testa se o arquivo est no temporrio do Windows
{-------------------------------------------------------------}

function testaArqTemp (nomeArq: string): boolean;
var
    dirWindowsTemp: string;
    tempPath: array [0..144] of char;
begin
    getTempPath (144, tempPath);
    dirWindowsTemp := strPas (tempPath);
    if pos (dirWindowsTemp, nomeArq) <> 0 then
        testaArqTemp := true
    else
        testaArqTemp := false;
end;

{-------------------------------------------------------------}
{       Confirma o destino da carta
{-------------------------------------------------------------}

function confirmaDestino (nomeDest:string): boolean;
var c, c2: char;
begin
    confirmaDestino := true;
    repeat
        textBackground (MAGENTA);
        mensagem ('CTENVPAR', 0);   {'Enviando para: '}
        textBackground (BLACK);   clreol;
        sintWriteln (nomeDest);
        mensagem ('CTCNFDST', 0);  {'Confirma destino {s/n) ? '}
        sintLeTecla (c, c2);
        writeln;
    until upcase (c) in ['S', 'N', ENTER, ESC];
    if upcase (c) in ['N', ESC] then
        confirmaDestino := false;
end;

{-------------------------------------------------------------}
{       Seleciona o destinatrio principal da carta
{-------------------------------------------------------------}

function selDestinoPrincipal (destinatario: string; editar: boolean): string;
var
    c: char;
    nomeDest: string;
    p: integer;
begin
    repeat
        nomeDest := destinatario;
        if editar then
            begin
                mensagem ('CTEDDEEN', 1); {Edite o nome do destinatrio e tecle ENTER.'}
                mensagem ('CTESOUAP', 1); {Setas escolhe outro no caderno de apelidos'}
                sintetiza (destinatario);
            end
        else
            begin
                mensagem ('CTENDDST', 1);  {'Qual o endereo eletrnico do destinatrio ? '}
                mensagem ('CTAPELID', 1);  {'Comear por * indica apelido'}
            end;
        c := sintEditaCampo (nomeDest, 1, wherey, 255, 80, true);
        writeln;

        if editar and (c = ESC) then
            begin
                mensagem ('CTDESIST', 2); {'Desistiu'}
                nomeDest := destinatario;
            end
        else
        if (c = ESC) or (upcase(c) = 'N') then
            nomeDest := 'ESC' //Cancela o envio retornando o ESC
        else
        if (c = BAIX) or (c = CIMA) then
            begin
                nomeDest := folhearApelidos;
                if (nomeDest <> '') and (not confirmaDestino (nomeDest)) then nomeDest := 'ESC';
            end
        else
        if (nomeDest <> '') and ( nomeDest [1] = '*') then
            begin
                delete (nomeDest, 1, 1);
                nomeDest := buscaApelido (nomeDest);
                if nomeDest = '' then
                    begin
                        nomeDest := 'ESC';
                        mensagem ('CTAPEINV', 2);   {'Apelido invlido'}
                    end
                else
                    if not confirmaDestino(nomeDest) then nomeDest :=
'ESC';
            end;

        p := pos (',', nomeDest);
        if p <> 0 then
            mensagem ('CTSOUMDS', 1);   {'Erro: informe apenas um destinatrio principal'}
    until p = 0;

    if editar and (  nomeDest <> destinatario) then
        mensagem ('CTOK', 2); {'OK'}

    selDestinoPrincipal := nomeDest;
end;

{-------------------------------------------------------------}
{       Edita o assunto da carta
{-------------------------------------------------------------}

function editaAssunto (assunto: string; var c: char): string;
var s: string;
begin
    s:= trim(assunto);
    repeat
        textBackground (RED);
        if s = '' then
            mensagem ('CTASSCAR', 0)  {'Qual o assunto da carta ? '}
        else
            begin
                mensagem ('CTEASSUN', 0);  {' Editore o assunto da carta'}
                sintetiza (s);
            end;
        textBackground (BLACK);
        writeln;
        c := sintEditaCampo (s, 1, wherey, 255, 80, true);
        writeln;
    until c in [ENTER, ESC];
    if c = ESC then
        editaAssunto := assunto
    else
        editaAssunto := s;

    if (assunto <> '') and (c = ESC) then
        msgBaixo ('CTDESIST') {'Desistiu'}
    else
    if assunto <> '' then
        msgBaixo ('CTOK'); {'OK'}
end;

{-------------------------------------------------------------}
{       Limpa as listas carbono:
{           O ocultas, C no ocultasou T ambas as listas
{-------------------------------------------------------------}

procedure limparTodasListas;
var c, c2: char;
begin
    repeat
        textBackground (RED);
        mensagem ('CTDELICA', 1); {'Deseja limpar a lista de cpias carbono?'}
        mensagem ('CTLISOCT', 1); {'Tecle O para ocultos, C para no ocultos ou T para ambas as listas')}
        sintLeTecla (c, c2);
        textBackground (BLACK);
        writeln;
    until upcase (c) in ['T', 'O', 'C', 'N', ESC];
    case upcase (c) of
        'C': limpaListaCarbono (pCC);
        'O': limpaListaCarbono (pBCC);
        'T': begin
                limpaListaCarbono (pCC);
                limpaListaCarbono (pBCC);
             end;
    else
        msgBaixo ('CTDESIST'); {'Desistiu'}
    end;
    if not (upcase (c) in ['N', ESC]) then
            mensagem ('CTOK', 1); {'OK'}
end;

{-------------------------------------------------------------}
{       Verificar listas carbono, pergunta qual a lista vai folhear
{-------------------------------------------------------------}

procedure verificarListasCarbono;
var c, c2: char;
begin
    if (pCC <> nil) and (pBCC <> nil) then
        repeat
            textBackground (RED);
            mensagem ('CTQLDFOL', 1); {'Qual lista carbono deseja folhear?'}
            mensagem ('CTTEOCCS', 1); {'Tecle O para carbono ocultos ou C para no ocultos'}
            sintLeTecla (c, c2);
            textBackground (BLACK);
            writeln;
        until upcase (c) in ['O', 'C', ESC]
    else
    if pCC <> nil then
        c := 'C'
    else
    if pBCC <> nil then
        c := 'O'
    else
        begin
            mensagem ('CTLICAVA', 1); {'Lista de copias carbono vazia.'}
            exit;
        end;

    if upcase (c) = 'C' then
        mensagem ('CTCOPCAR', 1) {'Copias carbono'}
    else
    if upcase (c) = 'O' then
        mensagem ('CTCOPCAO', 1); {'Copias carbono ocultas'}

    if c <> ESC then
        mensagem ('CTUSESET', 1); {'Folheando: use as setas, depois tecle sua opo'}
    case upcase (c) of
        'C': folheiaCopiasCarbono (pCC);
        'O': folheiaCopiasCarbono ( PBCC);
    else
        msgBaixo ('CTDESIST'); {'Desistiu'}
    end;

    if c <> ESC then
        msgBaixo ('CTOK'); {'OK'}
end;

{-------------------------------------------------------------}
{       Retorna o nome do arquivo txt a enviar
{-------------------------------------------------------------}

function escolheNomeArq (var editar: boolean): string;
var
    c, c2: char;
    nomeArq: string;
    arq: text;
begin
    escolheNomeArq := '';
    editar := true;
    mensagem ('CTNOMMAN', 1);  {'Qual o nome do arquivo de texto a mandar ? '}
    garanteEspacoTela (10);
    nomeArq := obtemNomeArq (10);
    writeln (nomeArq);

    if nomeArq = '' then
        begin
            nomeArq := dirEnvia + '\$.$';
            assign (arq, nomeArq);
            {$I-} rewrite (arq); {$I+}
            if ioresult <> 0 then
                begin
                    mensagem ('CTERRDSK', 1);  {'Erro de escrita no disco'}
                    exit;
                end;
            {$I-} close (arq); {$I+}
            if ioresult <> 0 then;

            escolheNomeArq := nomeArq;
            if teclaObtemNomeArq = ESC then
                begin
                    editar := false;
                    delay (100);
                    mensagem ('CTSEMTXT', 1);   {'Sem texto'}
                end;
            exit;
        end;

    if not testaExtensao (nomeArq) then
        begin
            if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) then
                begin
                    if (not existeArq (dirAtual + '\' + nomeArq)) and (not existeArq (dirEnvia + '\' + nomeArq)) then
                        nomeArq := nomeArq + '.txt';
                    if not existeArq (dirAtual + '\' + nomeArq) then
                        nomeArq := dirEnvia + '\' + nomeArq
                    else
                        nomeArq := dirAtual + '\' + nomeArq;
                end
            else
                if not existeArq (nomeArq) then
                    nomeArq := nomeArq + '.txt';
        end
    else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) then
            if not existeArq (dirAtual + '\' + nomeArq) then
                nomeArq := dirEnvia + '\' + nomeArq
            else
                nomeArq := dirAtual + '\' + nomeArq;

    if not existeArq (nomeArq) then
        begin
            repeat
                mensagem ('CTQUERTC', 0);  {'Esse arquivo no existe, quer teclar agora ? '}
                sintLeTecla (c, c2);
                writeln;
            until upcase (c) in ['S', 'N', ENTER, ESC];
            if upcase (c) in ['N', ESC] then exit;
        end
    else
        begin
            repeat
                mensagem ('CTEDIANT', 0);   {'Quer edita-lo antes de mandar ? '}
                sintLeTecla (c, c2);
                writeln;
            until upcase (c) in ['S', 'N', ENTER, ESC];
            if c = ESC then exit;
            if upcase (c) in ['N', ENTER] then editar := false;
        end;
    escolheNomeArq := nomeArq;
end;

{-------------------------------------------------------------}
{       Extrai a primeira parte da carta, txt ou html
{-------------------------------------------------------------}

function extraiArqCarta (nCar: integer): string;
var nomeArq: string;
begin
    extraiArqCarta := '';
    if not carregaLinhasArquivo (regLido[ncar]^.carta^.nomArqCarta) then
        begin
            msgBaixo ('CTCARSUM');  {'Erro no disco: carta sumiu'}
            exit;
        end;

    preencheCartaPrincipal (regLido[ncar]);//preenche o cabealho principal da carta
    if trim (regLido[ncar]^.boundary) = '' then
        begin
            if (maiuscAnsi(typeOuContent_type (RegLido[nCar])) = 'TEXT/PLAIN') or
               (maiuscAnsi(typeOuContent_type (RegLido[nCar])) = 'TEXT/HTML') or
               (trim (RegLido[nCar]^.content_type) = '') then
                    begin
                         nomeArq := gravaParteDecodificada (regLido[nCar], '');
                         if maiuscAnsi(typeOuContent_type (RegLido[nCar])) = 'TEXT/HTML' then
                              converteArqParaTxt (nomeArq);
                    end;
        end
    else
        begin
            criaIndicePartes;
            montaTudo (regLido[nCar]);

            if (maiuscAnsi(typeOuContent_type (listaDePartes[0])) = 'TEXT/PLAIN') or
               (maiuscAnsi(typeOuContent_type (listaDePartes[0])) = 'TEXT/HTML') then
                    begin
                         nomeArq := gravaParteDecodificada (listaDePartes[0], '');
                         if maiuscAnsi(typeOuContent_type (listaDePartes[0])) = 'TEXT/HTML' then
                              converteArqParaTxt (nomeArq);
                    end;

            destroiIndicePartes;
            desmontaTudo (regLido[ncar]);
        end;
    destroiLinhasArquivo;
    extraiArqCarta := nomeArq;
end;

{-------------------------------------------------------------}
{       Cria o arquivo e coloca a primeira parte da carta, se for text/plain
{-------------------------------------------------------------}

function preencheArqResposta (nCar: integer; perguntaSeAssina: boolean; encaminha: boolean; var nomeArq: string): boolean;
var
    arqOut: text;
    arquivoNaMemoria: boolean;
    i: integer;
    cancelar: char;
    s: string;

label fim;
begin
    preencheArqResposta := false;
    arquivoNaMemoria := false;
    nomeArq := extraiArqCarta (nCar);
    if trim (nomeArq) = '' then
        nomeArq := dirEnvia + '\$.$'
    else
        if not carregaLinhasArquivo (nomeArq) then
            begin
                msgBaixo ('CTCARSUM');  {'Erro no disco: carta sumiu'}
                exit;
            end
        else
            begin
                arquivoNaMemoria := true;
                assign (arqOut, nomeArq);
                {$I-} rewrite (arqOut); {$I+}
                if ioresult <> 0 then goto fim;
                {$I-} close (arqOut); {$I+}
                if ioresult <> 0 then goto fim;
            end;
    if perguntaSeAssina then
        nomeArq := anexaAssinatura (nomeArq, true, cancelar)
    else
        cancelar := 'N';
    if (cancelar = 'S') or (nomeArq = '') then goto fim;
    assign (arqOut, nomeArq);
    {$I-} append (arqOut);  {$i+}
    if ioresult <> 0 then
        begin
            {$I-} rewrite (arqOut); {$I+}
            if ioresult <> 0 then
                begin
                    msgBaixo ('CTERRLEI');  {'Erro de leitura do arquivo'}
                    exit;
                end;
        end;
    {$I-} writeln (arqOut, '');  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('CTERRDSK', 1);  {'Erro de escrita no disco'}
            goto fim;
        end;

    //Em 1 de Janeiro de 2010 16:50, Fulano de Tal
    //<fulano@provedor.com>escreveu:
    if cabecalhoResumido then
        begin
            s := regLido[nCar]^.carta^.from;
            i := pos('<', regLido[nCar]^.carta^.from);
            if i > 0 then s := copy(s, 1, i-1);
            {$I-} writeln (arqout, 'Em ' + converteData (regLido[nCar]^.carta^.date, true)+ ', ' + s);  {$I+}
            if ioresult <> 0 then;
            s := regLido[nCar]^.carta^.from;
            i := pos('<', regLido[nCar]^.carta^.from);
            if i > 0 then s := copy(s, i, length(s) - i + 1);
            {$I-} writeln (arqout, s + ' escreveu:');  {$I+}
            if ioresult <> 0 then;
        end
    else
        begin
            if encaminha then
                begin
                    {$I-} writeln (arqout, '-----Mensagem encaminhada-----');  {$I+}
                    if ioresult <> 0 then;
                end
            else
                begin
                    {$I-} writeln (arqout, '-----Mensagem original-----');  {$I+}
                    if ioresult <> 0 then;
                end;
            {$I-} writeln (arqout, 'De: ' + regLido[nCar]^.carta^.from);  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, 'Para: ' + regLido[nCar]^.carta^.to_);  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, 'Data: ' + converteData (regLido[nCar]^.carta^.date, true));  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, 'Assunto: ' + regLido [nCar]^.carta^.subject);  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, '');  {$I+}
            if ioresult <> 0 then;
        end;

    if arquivoNaMemoria then
        for i := 0 to linhasArquivo.count -1 do
            begin
                if cabecalhoResumido then
                    write (arqout, '> ');
                {$I-} writeln (arqout, linhasArquivo[i]);  {$I+}
                if ioresult <> 0 then;
            end;

    preencheArqResposta := true;
fim:
    if arquivoNaMemoria then
        destroiLinhasArquivo;
    {$I-} close (arqOut); {$I+}
    if ioresult <> 0 then;
end;

{-------------------------------------------------------------}
{       Ajuda das opes do preparo de carta
{-------------------------------------------------------------}

procedure ajudaOpcEnvio (tipo: char);
begin
    if tipo = 'P' then
        telaPrincipal
    else
        telaFolheamentoCartas;
    textBackground (BLUE);
    mensagem ('CTAJUD01', 0); {'As opes so:'}
    textBackground (BLACK);
    writeln;
    mensagem ('CTAJEN01', 1); {'A  Anexa arquivos'}
    mensagem ('CTAJEN02', 1); {'C  Cpias carbono'}
    mensagem ('CTAJEN08', 1); {'O  Cpias carbono ocultas'}
    mensagem ('CTAJEN03', 1); {'S  Edita o assunto'}
    mensagem ('CTAJEN04', 1); {'D  Edita o destinatrio'}
    mensagem ('CTAJEN05', 1); {'E  Reedita o arquivo da carta'}
    mensagem ('CTAJEN09', 1); {'F  Folheamento de listas carbono'}
    mensagem ('CTAJEN06', 1); {'L  Limpa a lista de copias carbono'}
    mensagem ('CTAJEN10', 1); {'R  Insere ou remove confirmao de recebimento'}
    mensagem ('CTAJEN07', 1); {'ESC  cancela'}
    if keypressed and (readkey <> ESC) then
        begin
            limpaBufTec;
            readkey;
        end;
    limpaBufTec;
end;

{-------------------------------------------------------------}
{       Seleciona as opes de envio com as setas
{-------------------------------------------------------------}

function selSetasOpcEnvio: char;
var
    n: integer;
const
    tabOpcEnvio: string [10] = 'ACOSDEFLR'+ESC;
begin
    popupMenuCria (35, wherey, 50, 9, RED);
    MenuAdiciona ('CTAJEN01'); {'A  Anexa arquivos'}
    MenuAdiciona ('CTAJEN02'); {'C  Cpias carbono'}
    MenuAdiciona ('CTAJEN08'); {'O  Cpias carbono ocultas'}
    MenuAdiciona ('CTAJEN03'); {'S  Edita o assunto'}
    MenuAdiciona ('CTAJEN04'); {'D  Edita o destinatrio'}
    MenuAdiciona ('CTAJEN05'); {'E  reedita o arquivo da carta'}
    MenuAdiciona ('CTAJEN09'); {'F  Folheamento de listas carbono'}
    MenuAdiciona ('CTAJEN06'); {'L  Limpa a lista de copias carbono'}
    MenuAdiciona ('CTAJEN10'); {'R  Insere ou remove confirmao de recebimento'}
    MenuAdiciona ('CTAJEN07'); {'ESC  cancela'}

    n := popupMenuSeleciona;

    if (n > 0) and (n <= 10) then
        selSetasOpcEnvio := tabOpcEnvio[n]
    else
        selSetasOpcEnvio := #0;
end;

procedure insereOuRemoveConfirmacaoRecebimento;
begin
    if confReceb then
    begin
        confReceb := false;

        mensagem('CTRECREM', 0); {'Confirmao de recebimento removido '}
    end
    else
    begin
        confReceb := true;
        mensagem('CTRECINC', 0); {'Confirmao de recebimento includo'}
    end;
end;

{-------------------------------------------------------------}
{   Prepara a carta para o envio
{   Tipos:
{       P - Prepara a partir do menu principal
{       R Responde a carta para o endereo do reply-to
{       CTRL+R - Responde a carta para o endereo do From
{       E - Encaminha a carta abrindo o texto
{       CTRL+E - Encaminha a carta como anexo
{-------------------------------------------------------------}

procedure prepararCarta (tipo: char; nCar: integer; editaPreparada: boolean; nomeDest: string);
var
    c, c2, cancelar: char;
    assunto, nomeArq, nomeArqEnviar, saveDir: string;
    message_id: string;
    editar: boolean;
    arq: text;

label desistiu, fim, desejaCancelar;
begin
    nArqMime := 0;  //Armazena nmero de arquivos em anexo
    limpaListaCarbono (pCC);
    limpaListaCarbono (pBCC);
    confReceb := false; //Desativa confirmao de recebimento

    if editapreparada then
        begin
            mensagem ('CTEDICAR', 1); {'Editando carta ...'}
            nomeDest := regLido[nCar]^.carta^.to_;
            assunto := regLido[nCar]^.carta^.subject;
            nomeArq := extraiArqCarta (nCar);
            chaveMime := trim(regLido[nCar]^.boundary);
            message_id := trim(regLido[nCar]^.carta^.message_id);
            carregaListaCarbono (regLido[nCar]^.carta^.cc, pCC);
            carregaListaCarbono (regLido[nCar]^.carta^.bcc, pBCC);
            textBackground (RED);
            mensagem ('CTQUALOP', 0); {'Qual sua opo? '}
            textBackground (BLACK);
        end
    else
        begin
            chaveMime := '';

            //  A baixo pega endereo do destinatrio
            if nomeDest <> '' then //e-mail entrou por parametro
                begin
                    if not  confirmaDestino (nomeDest) then
                        nomeDest := 'ESC';
                end
            else
            if tipo = 'P' then
                nomeDest := selDestinoPrincipal ('', false)
            else
            if tipo in ['E', ^E] then
                begin
                    if folheiaTransmitidas then
                        nomeDest := selDestinoPrincipal (regLido[nCar]^.carta^.to_, false)
                    else
                        nomeDest := selDestinoPrincipal (regLido [nCar]^.carta^.from, false);
                end
            else
            if tipo = ^R then
                begin
                    nomeDest := regLido [nCar]^.carta^.from;
                    if not  confirmaDestino (nomeDest) then
                        nomeDest := 'ESC';
                end
            else //tipo = R
                begin
                    if trim (regLido [nCar]^.carta^.reply_to) <> '' then
                        nomeDest := regLido [nCar]^.carta^.reply_to
                    else
                    nomeDest := regLido [nCar]^.carta^.from;
                    if not  confirmaDestino (nomeDest) then
                        nomeDest := 'ESC';
                end;
            if nomeDest = 'ESC' then
                goto desistiu;
            if (pos ('(', nomeDest) <> 0) and (pos ('(', nomeDest) > pos ('@', nomeDest)) then
                delete (nomeDest, pos('(', nomeDest), length (nomeDest));
            nomedest := trim(nomeDest);

            //  Pega assunto da carta
            if tipo = 'P' then
                assunto := editaAssunto ('', c)
            else
            if tipo in ['R', ^R] then
                assunto := 'Re: ' + limpaAssunto(regLido[nCar]^.carta^.subject)
            else //tipo in ['E', ^E]
                assunto := 'En: ' + limpaAssunto(regLido[nCar]^.carta^.subject);
            if c = ESC then goto desistiu;

            //Pega a identificao para carta resposta e encaminhada
            if tipo <> 'P' then
                message_id := trim(regLido[nCar]^.carta^.message_id)
            else
                message_id := '';

            //  Pega cpias carbono, somente na resposta
            if tipo in ['R', ^R] then
                if not respondeTodosCC (nCar) then
                    goto desistiu; //Cancela o envio

            //  Pega nome do arquivo para envio
            if tipo = 'P' then
                begin
                    getDir (0, dirAtual);
                    nomeArq := escolheNomeArq (editar);
                end
            else
            if tipo in ['R', ^R] then
                begin
                    if (not preencheArqResposta (nCar, true, false, nomeArq)) and (nomeArq <> '') then goto fim;
                    editar := true;
                end
            else
                begin
                    if (not preencheArqResposta (nCar, tipo = 'E', true, nomeArq)) and (nomeArq <> '') then goto fim;
                    editar := tipo = 'E';
                end;
            if trim (nomeArq) = '' then
                goto desistiu;

            //  Abre corpo principal da carta para edio
            if editar then
                begin
                    mensagem ('CTABREDI', 1);  {'Abrindo editor'}
                    editaArquivo (nomeArq);
                    limpaBufTec;
                    sintBip;
                end;

            //  Adiciona arquivo de assinatura, se existir
            if tipo = 'P' then nomeArq := anexaAssinatura (nomeArq, false, cancelar);
            if nomeArq = '' then goto desistiu;
            if cancelar = 'S' then goto desejaCancelar;

            //Insere confirmao de leitura automaticamente
            if inserirConfRec then
                insereOuRemoveConfirmacaoRecebimento;

            if (tipo in ['E', ^E]) and (trim(regLido[nCar]^.boundary) <> '') then
                chaveMime := trim(regLido[nCar]^.boundary);
        end;

    repeat
        writeln;
        textBackground (RED);
        mensagem ('CTENTFEC', 0); {'Tecle ENTER para fechar a carta ou F1 para conhecer outras opes'}
        textBackground (BLACK);
        sintLeTecla (c, c2);
        writeln;

        if c = #0 then
            if c2 = F1 then
                ajudaOpcEnvio (tipo)
            else
            if c2 in [BAIX, CIMA] then
                c := selSetasOpcEnvio;

        case upcase (c) of
            'A': begin
                    getDir (0, saveDir);
                    {$I-}  chdir (dirAtual);  {$I+}
                    if ioresult <> 0 then;
                    atachaArquivos ('');
                    {$I-}  chdir (saveDir);  {$I+}
                    if ioresult <> 0 then;
                 end;
            'C': geraListaCarbono (nomeDest, false);
            'O': geraListaCarbono (nomeDest, true);
            'S': assunto := editaAssunto (assunto, c2);
            'D': nomeDest := selDestinoPrincipal (nomeDest, true);
            'E': editaArquivo (nomeArq);
            'F': verificarListasCarbono;
            'L': limparTodasListas;
            'R': insereOuRemoveConfirmacaoRecebimento;

            #0, ENTER:;//No faz nada.
            ESC: begin
desejaCancelar:
                    writeln;
                    textBackground (RED);
                    if editaPreparada then
                        mensagem ('CTCAEDCA', 0) {'Deseja realmente cancelar a edio desta carta?'}
                    else
                        mensagem ('CTCAPREC', 0); {'Deseja realmente cancelar o preparo desta carta?'}
                    textBackground (BLACK);
                    sintLeTecla (c, c2);
                    writeln;
                    if upcase (c) = 'S' then c := ESC
                    else c := #0;
                 end;

        else
            mensagem ('CTOPVINV', 1); {'Opo invlida, aperte F1 para ajuda'}
        end;
        if (c = ENTER) and (trim(nomeDest) = '') and (pCC = nil) and (pBCC = nil) then
            begin
                Mensagem ('CTSEMDES', 1); {'Carta sem destinatrio.'}
                nomeDest := selDestinoPrincipal (nomeDest, false);
                if nomeDest = 'ESC' then nomeDest := '';
                c := #0;
            end;

    until upcase (c) in [ENTER, ESC];

    if c <> ESC then
        begin
            nomeArqEnviar := geraTextoSMTP (nomeArq, nomeDest, assunto,
                                            pCc, pBcc, tipo in ['E', ^E],
                                            confReceb, false, nCar, message_id);
            if (editaPreparada) and (trim (nomeArqEnviar) <> '') then
                begin
                    assign (arq, regLido [nCar]^.carta^.nomArqCarta);
                    {$I-}  erase (arq);  {$I+}
                    if ioresult <> 0 then;
                    regLido[nCar]^.carta^.nomArqCarta := nomeArqEnviar;
                    regLido[nCar]^.carta^.preenchido := false;
                    carregaArqPreencheCabPrin (nCar);
                end;
        end
    else
        begin
            if editaPreparada then
                mensagem ('CTEDICAN', 2) {'Edio cancelada'}
            else
                begin
                    mensagem ('CTOK', 0); {'Ok'}
                    write (' ');
                    mensagem ('CTCANCEL', 2); {'cancelado'}
                end;
            if pCC <> nil then
                limpaListaCarbono (pCC);
            if pBCC <> nil then
                limpaListaCarbono (pBCC);
        end;

    goto fim;
desistiu:
    mensagem ('CTDESIST', 2);   {'Desistiu...'}
fim:
            deletaAspas (nomeArq);
            if testaArqTemp (nomeArq) then
                begin
                    assign (arq, nomeArq);
                    {$I-}  erase (arq);  {$I+}
                    if ioresult <> 0 then;
                end;
    assign (arq, dirEnvia+'\$.$');
    {$I-} erase (arq); {$I+}
    if ioresult <> 0 then;
end;

{-------------------------------------------------------------}
{      Extrai a primeira parte da carta, txt ou html,
{      para a resposta automtica
{-------------------------------------------------------------}

function extraiArqCartaRespAut (nCar: integer): string;
var nomeArq: string;
begin
    extraiArqCartaRespAut := '';
    if not carregaLinhasArquivo (regLidoRespAut[ncar]^.carta^.nomArqCarta) then
        begin
            msgBaixo ('CTCARSUM');  {'Erro no disco: carta sumiu'}
            exit;
        end;

    preencheCartaPrincipal (regLidoRespAut[ncar]);//preenche o cabealho principal da carta
    if trim (regLidoRespAut[ncar]^.boundary) = '' then
        begin
            if (maiuscAnsi(typeOuContent_type (regLidoRespAut[nCar])) = 'TEXT/PLAIN') or
               (maiuscAnsi(typeOuContent_type (regLidoRespAut[nCar])) = 'TEXT/HTML') or
               (trim (regLidoRespAut[nCar]^.content_type) = '') then
                    begin
                         nomeArq := gravaParteDecodificada (regLidoRespAut[nCar], '');
                         if maiuscAnsi(typeOuContent_type (regLidoRespAut[nCar])) = 'TEXT/HTML' then
                              converteArqParaTxt (nomeArq);
                    end;
        end
    else
        begin
            criaIndicePartes;
            montaTudo (regLidoRespAut[nCar]);

            if (maiuscAnsi(typeOuContent_type (listaDePartes[0])) = 'TEXT/PLAIN') or
               (maiuscAnsi(typeOuContent_type (listaDePartes[0])) = 'TEXT/HTML') then
                    begin
                         nomeArq := gravaParteDecodificada (listaDePartes[0], '');
                         if maiuscAnsi(typeOuContent_type (listaDePartes[0])) = 'TEXT/HTML' then
                              converteArqParaTxt (nomeArq);
                    end;

            destroiIndicePartes;
            desmontaTudo (regLidoRespAut[ncar]);
        end;
    destroiLinhasArquivo;
    extraiArqCartaRespAut := nomeArq;
end;

{-------------------------------------------------------------}
{     Cria o arquivo e coloca a primeira parte da carta,
{     se for text/plain, para a resposta automtica
{-------------------------------------------------------------}

function preencheArqRespAut (nCar: integer; perguntaSeAssina: boolean; var nomeArq: string): boolean;
var
    arqOut: text;
    arquivoNaMemoria: boolean;
    i: integer;
    cancelar: char;
    s: string;

label fim;
begin
    preencheArqRespAut := false;
    arquivoNaMemoria := false;
    nomeArq := extraiArqCartaRespAut (nCar);
    if trim (nomeArq) = '' then
        nomeArq := dirEnvia + '\$.$'
    else
        if not carregaLinhasArquivo (nomeArq) then
            begin
                msgBaixo ('CTCARSUM');  {'Erro no disco: carta sumiu'}
                exit;
            end
        else
            begin
                arquivoNaMemoria := true;
                assign (arqOut, nomeArq);
                {$I-} rewrite (arqOut); {$I+}
                if ioresult <> 0 then goto fim;
                {$I-} close (arqOut); {$I+}
                if ioresult <> 0 then goto fim;
            end;
    if perguntaSeAssina then
        nomeArq := anexaAssinatura (nomeArq, true, cancelar)
    else
        cancelar := 'N';
    if (cancelar = 'S') or (nomeArq = '') then goto fim;
    assign (arqOut, nomeArq);
    {$I-} append (arqOut);  {$i+}
    if ioresult <> 0 then
        begin
            {$I-} rewrite (arqOut); {$I+}
            if ioresult <> 0 then
                begin
                    msgBaixo ('CTERRLEI');  {'Erro de leitura do arquivo'}
                    exit;
                end;
        end;
    {$I-} writeln (arqOut, '');  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('CTERRDSK', 1);  {'Erro de escrita no disco'}
            goto fim;
        end;

    //Em 1 de Janeiro de 2010 16:50, Fulano de Tal
    //<fulano@provedor.com>escreveu:
    if cabecalhoResumido then
        begin
            s := regLidoRespAut[nCar]^.carta^.from;
            i := pos('<', regLidoRespAut[nCar]^.carta^.from);
            if i > 0 then s := copy(s, 1, i-1);
            {$I-} writeln (arqout, 'Em ' + converteData (regLidoRespAut[nCar]^.carta^.date, true)+ ', ' + s);  {$I+}
            if ioresult <> 0 then;
            s := regLidoRespAut[nCar]^.carta^.from;
            i := pos('<', regLidoRespAut[nCar]^.carta^.from);
            if i > 0 then s := copy(s, i, length(s) - i + 1);
            {$I-} writeln (arqout, s + ' escreveu:');  {$I+}
            if ioresult <> 0 then;
        end
    else
        begin
            {$I-} writeln (arqout, '-----Mensagem original-----');  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, 'De: ' + regLidoRespAut[nCar]^.carta^.from);  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, 'Para: ' + regLidoRespAut[nCar]^.carta^.to_);  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, 'Data: ' + converteData (regLidoRespAut[nCar]^.carta^.date, true));  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, 'Assunto: ' + regLidoRespAut [nCar]^.carta^.subject);  {$I+}
            if ioresult <> 0 then;
            {$I-} writeln (arqout, '');  {$I+}
            if ioresult <> 0 then;
        end;

    if arquivoNaMemoria then
        for i := 0 to linhasArquivo.count -1 do
            begin
                if cabecalhoResumido then
                    write (arqout, '> ');
                {$I-} writeln (arqout, linhasArquivo[i]);  {$I+}
                if ioresult <> 0 then;
            end;

    preencheArqRespAut := true;
fim:
    if arquivoNaMemoria then
        destroiLinhasArquivo;
    {$I-} close (arqOut); {$I+}
    if ioresult <> 0 then;
end;

{-------------------------------------------------------------}
{   Prepara a carta da resposta automtica para a transmisso
{-------------------------------------------------------------}

procedure prepararCartaRespAut (quantCartas: integer; vaiEnviar: boolean);
var
    tipo: char;
    nomeDest, message_id: string;
    assunto, nomeArq, nomeArqEnviar, nomArqCarta: string;
    arq: text;
    i: integer;

label fim, fim2, erro;
begin
    tipo := 'E';
    nArqMime := 0;

    //Monta a lista de cartas
    montaListaDeCartasRespAut;

    //Destri a lista com o nome dos arquivos CAR
    destroiListaCAR;

    //Tratamento de exceo, Testa se a lista foi montada, caso no tenha sido, vai para o fim2
    for i := 1 to quantCartas do
        if regLidoRespAut [i] = nil then goto fim2;

    //Cria a lista para guardar o nome dos arquivos CPR das respostas que sero enviadas
    if vaiEnviar then criaListaCPR;

    for i := 1 to quantCartas do
        begin
            //Carrega os dados da carta a ser respondida
            carregaArqPreencheCabPrinRespAut (i);

            //Aqui comea o carEnvia
            limpaListaCarbono (pCC);
            limpaListaCarbono (pBCC);

            chaveMime := '';
            assunto := '';

            //Pega o endereo de destino da carta
            nomeDest := regLidoRespAut[i]^.carta^.from;
            //Pega o nome do arquivo da carta
            nomArqCarta := regLidoRespAut[i]^.carta^.nomArqCarta;

            if (pos ('(', nomeDest) <> 0) and (pos ('(', nomeDest) > pos ('@', nomeDest)) then
                delete (nomeDest, pos('(', nomeDest), length (nomeDest));
            nomedest := trim(nomeDest);

            //Ajusta o nome do assunto da carta
            if assRespAut <> '' then assunto := ' - ' + assRespAut;
            assunto := 'Re: ' + limpaAssuntoLista (regLidoRespAut[i]^.carta^.subject) + assunto;

            //Pega a identificao para carta resposta
            message_id := trim(regLidoRespAut[1]^.carta^.message_id);

            //Cria o arquivo inicial da carta
            //false: no pergunta se adiciona a assinatura, isso deve ser feito na montagem da resposta automtica
            if (not preencheArqRespAut (i, false, nomeArq)) and (nomeArq <> '') then goto fim;

            nomeArq := colocaRespostaCarta(nomeArq);
            if nomeArq = 'erro' then goto fim2;

            nomeArqEnviar := geraTextoSMTP (nomeArq, nomeDest, assunto, pCc, pBcc, tipo = 'E', confReceb, true, i, message_id);

            if vaiEnviar then adicionaListaCPR (nomeArqEnviar);

            fim:
                deletaAspas (nomeArq);
                if testaArqTemp (nomeArq) then
                    begin
                        assign (arq, nomeArq);
                        {$I-}  erase (arq);  {$I+}
                        if ioresult <> 0 then;
                    end;
                assign (arq, dirEnvia+'\$.$');
                {$I-} erase (arq); {$I+}
                if ioresult <> 0 then;
        end;

        fim2:
            while numRegsRespAut > 0 do
                begin
                    regLidoRespAut[numRegsRespAut]^.carta^.partesCarta.free;
                    dispose (regLidoRespAut[numRegsRespAut]);
                    regLidoRespAut[numRegsRespAut] := nil;
                    numRegsRespAut := numRegsRespAut - 1;
                end;
end;

{--------------------------------------------------------}
begin
end.
