{--------------------------------------------------------}
{
{           Cartavox - Folheador de cartas
{
{--------------------------------------------------------}

unit carFolhe;

interface

uses
    dvarq,
    dvcrt,
    dvform,
    dvhora,
    dvWin,
    sysutils,
    windows,
    carApeli,
    carCopia,
    carDecod,
    carEnvia,
    carEst,
    carLeit,
    carList,
    carMsg,
    carSMTP,
    carTela,
    carUtil,
    carVars,
    carSpam,
    carResp;

procedure folhearCartas (tipoFolheamento: char; pastaRegra: string = '');

implementation

var
    folheiaRecebidas: boolean;

{-------------------------------------------------------------}
{       Retorna somente o e-mail de uma string
{-------------------------------------------------------------}

function retornaEmail (s: string): string;
var
    saida: string;
    i, f: integer;
label fim;
begin
    saida := s;
    if trim (s) = '' then goto fim;
    i := pos ('<', s);
    f := pos ('>', s);
    if i >= f then goto fim;
    saida := copy (s, i+1, f-i+1);
fim:
    retornaEmail := saida;
end;

{--------------------------------------------------------}
{       procura uma string no cabealho da carta ou na carta toda
{--------------------------------------------------------}

procedure procurarNaCarta (folheiaAchados: boolean; nCar: integer);
var
    c, c2: char;
    atual, cont, i, total: integer;
    achouJaUma, selecionado: boolean;
    textoBusc: string;



    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;


    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := trim (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := linhasArquivo[i];
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, maiuscansi (semAcentos (s))) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'A': begin //nenoneno
                    if trim(limpaAssunto(regLido [nCar]^.carta^.subject)) = '' then
                        procuraUmItem := textoBusc = (regLido [nCar]^.carta^.subject)
                    else
                        procuraUmItem := textoBusc = limpaAssunto(regLido [nCar]^.carta^.subject);
                 end;
            'D': procuraUmItem := pos (textoBusc, regLido [nCar]^.carta^.delivered_to + regLido [nCar]^.carta^.to_ + regLido [nCar]^.carta^.bcc) <> 0;
            'R': procuraUmItem := textoBusc = retornaEmail (regLido [nCar]^.carta^.from);
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;


    procedure ajuda;
    begin
        mensagem ('CTAJUD01', 2); {'As opes so'}
        if not keypressed then
            mensagem ('CTCABCAR',1); {' C - Cabealho da carta'}
        if not keypressed then
            mensagem ('CTCORCAR',1); {' B - Corpo da carta'}
        if not keypressed then
            mensagem ('CTTODCAR',1); {' T - Toda carta'}
        if not keypressed then
            mensagem ('CTPROASS',1); {' A - Assunto desta carta'}
        if not keypressed then
            mensagem ('CTPROREM',1); {' R - Remetente desta carta'}
        if not keypressed then
            mensagem ('CTPRODES',1); {' D - Destinatrio desta carta'}
        if not keypressed then
            mensagem ('CTPRODAT', 1); {' H - Data de chegada desta carta'}
    end;


    function selSetas: char;
    var
        n: integer;
    const tabOpc: string[7] = 'CBTARDH';
    begin
        popupMenuCria (35, wherey, 50, 7, RED);
        MenuAdiciona ('CTCABCAR'); {' C - Cabealho da carta'}
        MenuAdiciona ('CTCORCAR'); {' B - Corpo da carta'}
        MenuAdiciona ('CTTODCAR'); {' T - Toda carta'}
        MenuAdiciona ('CTPROASS'); {' A - Assunto desta carta'}
        MenuAdiciona ('CTPROREM'); {' R - Remetente desta carta'}
        MenuAdiciona ('CTPRODES'); {' D - Destinatrio desta carta'}
        MenuAdiciona ('CTPRODAT'); {' H - Data de chegada desta carta'}

        n := popupMenuSeleciona;
        if (n >=1) and (n <= 7) then
            selSetas := tabOpc [n]
        else
            selSetas := #0;
    end;


begin
    c2 := #$0;
    if agruparPorAssunto then
        c:= 'A'
    else
    repeat
        limpaParteTela (20, 25);
        if not folheiaAchados then
            mensagem ('CTPROINV', 1); {'Procura invertida'}
        mensagem ('CTTIPPRO', 0); {'Qual o tipo de procura?'}
        write ('   ');
        mensagem ('CTF1AJUD', 1);         {'F1 ajuda '}
        c := upcase (readkey);
        if c = #0 then
            begin
                c := readkey;
                if c = F1 then ajuda
                else
                if (c = BAIX) or (c = CIMA) then c := selSetas;
            end;
    until c in ['C', 'T', 'B', 'A', 'R', 'D', 'H', ESC, ENTER];
    if not agruparPorAssunto then
        sintWriteln (c);

    if c in ['A', 'R', 'D'] then
        for i := 1 to numRegs do
            if not regLido [i]^.carta^.preenchido then
                begin
                    selecionado := regLido [i]^.selecionado;
                    carregaArqPreencheCabPrin ( i);
                    regLido [i]^.selecionado := selecionado;
                    if (i mod 500) = 0 then sintclek;
                end;

    case c of
        'A': begin
                textoBusc := limpaAssunto(regLido [nCar]^.carta^.subject);
                if trim (textoBusc) = '' then
                    textoBusc := regLido [nCar]^.carta^.subject;
             end;
        'D': if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
                textoBusc := retornaEmail (regLido [nCar]^.carta^.delivered_to)
             else
             if trim (regLido [nCar]^.carta^.to_) <> '' then
                textoBusc := retornaEmail (regLido [nCar]^.carta^.to_)
             else
                textoBusc := retornaEmail (regLido [nCar]^.carta^.bcc);
        'R': textoBusc := retornaEmail (regLido [nCar]^.carta^.from);
        'H': textoBusc := dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
    else
        repeat
            textoBusc := 'reply-to';
            if c in ['C', ENTER] then
                mensagem ('CTINFPRO', 1)    {'Informe o texto a procurar no cabealho da carta'}
            else
            if C = 'T' then
                mensagem ('CTINPROT', 1)    {'Informe o texto a procurar em toda carta'}
            else
            if c = 'B' then
                mensagem ('CTPROCOR', 1)    {'Informe o texto a procurar no corpo da carta'}

            else
                begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
                    exit;
                end;
            c2 := sintEditaCampo (textoBusc, 1, wherey, 255, 80, true);
            textoBusc := maiuscansi (semAcentos (textoBusc));
        until c2 in [ENTER, ESC];
    end;

    if (c2 = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
            msgBaixo ('CTACHEI')     {'Achei'}
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{-------------------------------------------------------------}
{       Trata o reenvio da carta
{-------------------------------------------------------------}

procedure reenviarCarta (nCar: integer);
var
    c, c2: char;
    reenviarSelecionadas: boolean;
begin
    repeat
        limpaParteTela (19, 25);
        textBackground (RED);
        if temItemSelecionado then
            mensagem ('CTREESEL', 0)   {'Deseja reenviar todas as selecionadas? '}
        else
            mensagem ('CTREECAR', 0); {'Deseja reenviar esta carta? '}
        sintLeTecla (c, c2);
        textBackground (BLACK);
        writeln;
    until upcase (c) in ['S', 'N', ENTER, ESC];

    if (upcase(c) = ESC) or (not temItemSelecionado and (upcase(c) = 'N')) then
        begin
            msgBaixo ('CTDESIST');  {'Desistiu'}
            exit;
        end;

    if temItemSelecionado then
        reenviarSelecionadas := upcase(c) in ['S', ENTER]
    else
        reenviarSelecionadas := false;
    if not reenviarSelecionadas then
        begin
            if tiraCopia (regLido[nCar]^.carta^.nomArqCarta) then
                msgBaixo ('CTCARPRP'); {'Carta preparada para envio'}
        end
    else
    for nCar := 1 to numRegs do
        if regLido[nCar]^.selecionado then
            if not tiraCopia (regLido[nCar]^.carta^.nomArqCarta) then exit;

    if reenviarSelecionadas then
        if totalDeItensSelecionados > 1 then
            msgBaixo ('CTCARPRS') {'Cartas preparadas para envio'}
        else
            msgBaixo ('CTCARPRP'); {'Carta preparada para envio'}

end;

{--------------------------------------------------------}
{       informacoes sobre a carta
{--------------------------------------------------------}

procedure infoCarta (nCar: integer);
var data: string;

const
    tabDias: array [1..7] of string =
        ('Domingo', 'Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sabado');

begin
    delay (10);
    sintetiza (nomeConfiguracao);
    delay (100);
    limpaParteTela (18, 25);
    textBackground (RED);
    mensagem ('CTASSUNT', 0);  {'Assunto: '}
    textBackground (BLACK);
    writeln;
    sintWriteln (regLido [nCar]^.carta^.subject);
    contemAnexos (nCar);
    textBackground (RED);
    mensagem ('CTENVPOR', 0);  {'Enviada por '}
    textBackground (BLACK);
    writeln;
    sintWriteln ( regLido [nCar]^.carta^.from);
        limpaParteTela (22, 25);
        textBackground (RED);
    mensagem ('CTDATENV', 0);  {'Data de envio: '}
    textBackground (BLACK);
    data := regLido [nCar]^.carta^.date;
    data := converteData (data, true);
    if data <> '' then
        sintWriteln (data);
    textBackground (RED);
    mensagem ('CTDATCHE', 0);  {'Data de chegada: '}
    textBackground (BLACK);
    sintetiza (tabDias [dayOfWeek (fileDateToDateTime (
        reglido [nCar]^.carta^.datahora))]         + ' ' +
        dateToStr (fileDateToDateTime (regLido[nCar].carta^.datahora)) + ' ' +
        timeToStr(FileDateToDateTime(regLido[nCar].carta^.datahora)));
    textBackground (RED);
    mensagem ('CTARQUIV', 0);  {'Arquivo '}
    textBackground (BLACK);
    sintwriteln(regLido [nCar]^.carta^.nomArqCarta);
end;

{--------------------------------------------------------}
{       associa nome a um apelido
{--------------------------------------------------------}

procedure selecionaApelido (nCar: integer);
var
    c:char;
   nome, apelido, s: string;
   k: integer;

label outroApelido;
begin
    if folheiaRecebidas then
        nome := regLido [nCar]^.carta^.from
    else
        nome := regLido [nCar]^.carta^.to_;

    if pos ('<', nome) = 0 then
        nome := '"' + nome + '" <' + nome + '>'
    else
    if pos ('"', nome) = 0 then
        begin
            k := pos ('<', nome);
            s := copy (nome, 1, k-1);
            delete (nome, 1, k);
            nome := '"' + s + '" <' + nome;
        end;

outroApelido:
    repeat
        limpaParteTela (20, 25);
        textBackground (RED);
        mensagem ('CTQAPELI', 0);    {'Informe o apelido desejado para '}
        textBackground (BLACK);
        writeln;
        sintWriteln (nome);

        apelido := nome;
        delete (apelido, 1, 1);
        apelido := copy (apelido, 1, pos ('"', apelido)-1);
        c := sintEditaCampo (apelido, 1, wherey, 255, 80, true);
        writeln;
    until c in [ENTER, ESC];
    if c = ESC then
        begin
            msgBaixo ('CTDESIST');   {'Desistiu'}
            exit;
        end;

    if apelido <> '' then
        begin
            if apelido[1] in [';', '[', '.', '=', '<', '''', '"'] then
                begin
                    msgBaixo ('CTAPEINV'); {'Apelido invlido'}
                    exit;
                end;

            if buscaApelido (apelido) <> '' then
                begin
                    repeat
                        limpaParteTela (20, 25);
                        textBackground (RED);
                        mensagem ('CTAPJAEX', 1); {'Apelido j existe, se manter este, apagar o anterior'}
                        mensagem ('CTDEESOU', 0); {'Deseja escolher outro?'}
                        mensagem ('CTSIMNAO', 0); {'(S/N) ? '}
                        c := upcase (sintReadkey);
                        writeln (c);
                    until c in ['S', 'N', ENTER, ESC];
                    if c = ESC then
                        begin
                            msgBaixo ('CTDESIST');   {'Desistiu'}
                            exit;
                        end
                    else
                    if not (upcase (c) in ['N', ENTER]) then
                        goto outroApelido;
                end;

            s := copy (nome, (pos('<', nome)+1), (pos ('>', nome) -1) - (pos('<', nome)+1));
            if not procuraEmail (s) then
                begin
                    trocaApelido (apelido, nome);
                    msgBaixo ('CTOK');   {'Ok'}
                end
            else
        msgBaixo ('CTEMJAEX');   {'e-mail j existe.'}
        end
    else
        msgBaixo ('CTDESIST');   {'Desistiu'}
end;

{-------------------------------------------------------------}
{       Escolhe o tipo de ordenao da lista de cartas
{-------------------------------------------------------------}

procedure escolheOrdenacao;

    procedure ajuda;
    begin
        telaFolheamentoCartas;
        textBackground(BLUE);
        if not keypressed then
            mensagem ('CTAJOR00', 2);  {'Os tipos de ordenao so:'}
        textBackground(BLACK);

        mensagem ('CTAJOR01', 1);  {'C - Data de chegada'}
        mensagem ('CTAJOR02', 1);  {'E - Data de Envio'}
        mensagem ('CTAJOR03', 1);  {'A - Assunto'}
        mensagem ('CTAJOR04', 1);  {'N - Nome'}
        mensagem ('CTAJOR05', 1);  {'T - Tamanho'}
        clreol;
        writeln;
        if keypressed and (readkey <> ESC) then
            begin
                limpaBufTec;
                readkey;
            end;
        limpaBufTec;
    end;

    function selSetasFolheia: char;
    var
        n: integer;
    const
        tabOrd: string [5] = 'CEANT';
    begin
        popupMenuCria (35, wherey, 50, 5, RED);
        MenuAdiciona ('CTAJOR01'); {'C - Data de chegada'}
        MenuAdiciona ('CTAJOR02');  {'E - Data de Envio'}
        MenuAdiciona ('CTAJOR03');  {'A - Assunto'}
        MenuAdiciona ('CTAJOR04');  {'N - Nome'}
        MenuAdiciona ('CTAJOR05');  {'T - Tamanho'}
        n := popupMenuSeleciona;
        if (n > 0) and (n <= 5) then
            selSetasFolheia := tabOrd [n]
        else
            selSetasFolheia := ' ';
    end;

var c, c2: char;
begin
    telaFolheamentoCartas;
    writeln;
    writeln;

    mensagem ('CTQUATOR', 1); {'Qual o tipo de ordenao?'}
    mensagem ('CTF1AJUD', 0); {'F1 ajuda '}
    sintLeTecla (c, c2);
    writeln;

    if (c = #0) and (c2 in [BAIX, CIMA]) then
        c := selSetasFolheia
    else
    if c = #0 then
        begin
            ajuda;
            escolheOrdenacao;
            exit;
        end;

    case upcase (c) of
        'C': ordenarLista ('datahora', true);
        'E': ordenarLista ('date', true);
        'N': if folheiaRecebidas then
                    ordenarLista ('from', true)
             else
                    ordenarLista ('to_', true);
        'A': ordenarLista ('subject', true);
        'T': ordenarLista ('tamanho', true);
    else
        if c <> ESC then
            mensagem ('CTOPCINV', 2)   {'Opo invlida'}
        else
            mensagem ('CTDESIST', 2); {'Desistiu'}
    end;
end;

{--------------------------------------------------------}
{       ajuda no folheamento
{--------------------------------------------------------}

procedure ajudaFolheia;
begin
    telaFolheamentoCartas;
    textBackground(BLUE);
    if not keypressed then
        mensagem ('CTAJFL01', 2);  {'Folheie as cartas com as setas, depois tecle:'}
    textBackground(BLACK);

    mensagem ('CTAJFL02', 1);  {'L ou ENTER - para ler carta'}
    if folheiaRecebidas then
        mensagem ('CTAJFL5B', 1);  {'R - responder carta'}
    if folheiaRecebidas or folheiaTransmitidas then
        mensagem ('CTAJFL5C', 1)  {'E - encaminhar carta'}
    else
    if not folheiaTransmitidas then
        mensagem ('CTAJFL5F', 1);  {'E - editar carta'}
    if folheiaRecebidas then
        mensagem ('CTAJFL09', 1)   {'S - selecionar o nome do remetente associando-o a um apelido'}
    else
        mensagem ('CTAJFL9A', 1);  {'S - selecionar o nome do destinatrio associando-o a um apelido'}
    mensagem ('CTAJFL04', 1);      {'A - apagar a carta'}
    if not folheiaRecebidas then
        mensagem ('CTAJFL03', 1);  {'I - para obter informaes sobre a carta'}
    mensagem ('CTAJFL06', 1);      {'C - copiar'}
    if folheiaRecebidas then
        mensagem ('CTAJFL08', 1);  {'T - transmitir cartas j digitadas'}
    if not folheiaRecebidas then
        mensagem ('CTAJFL12', 1);  {'O - editar o texto original da carta'}
    mensagem ('CTAJFL07', 2);      {'ESC terminar folheamento'}
    mensagem ('CTATCLF9', 0);      {'Tecle F9 para selecionar a opo com as setas'}

    textBackground(BLACK);  clreol;
    writeln;
    if keypressed and (readkey <> ESC) then
        begin
            limpaBufTec;
            readkey;
        end;
    limpaBufTec;
end;

{--------------------------------------------------------}
{       seleciona a funo com as setas
{--------------------------------------------------------}

function selSetasFolheia (Var c: char): char;
var
    n,nOpc: integer;
const
    tabLRec: string [33] = 'LR'+^R+'E'+^E+'SUAICTOQ'+ ^Q+ 'D'+ ^D+ 'NG'+ ^N+ ^G+ 'M'+
                           ^T+ 'BF'+ ^F+ 'V'+ ^L+ ^B+ F3+ F5+ F6+ ESC;
    tabLTra: string [27] = 'L'+'E'+^E+'SAICTROQ'+ ^Q+ 'D'+ ^D+ 'NG'+ ^N+ ^G+ 'BF'+
                           ^F+ 'V'+ F3+ F5+ F6+ ESC;
    tabLPre: string [25] = 'LESAICTOQ'+ ^Q+ 'D'+ ^D+ 'NG'+ ^N+ ^G+ 'BF'+
                           ^F+ 'V'+ F3+ F5+ F6+ ESC;

begin
    if folheiarecebidas then
        nOpc := 33
    else
    if folheiaTransmitidas then
        nOpc := 27
    else
        nOpc := 25;

    popupMenuCria (35, wherey, 50, nOpc, RED);
    MenuAdiciona ('CTAJFL02');  {'L ou ENTER - para ler carta'}
    if folheiaRecebidas then
        begin
            MenuAdiciona ('CTAJFL5B');  {'R - Responder carta'}
            MenuAdiciona ('CTAJFL5E');  {'CTRL+R - Responder para o remetente'}
        end;
    if folheiaRecebidas or folheiaTransmitidas then
        begin
            MenuAdiciona ('CTAJFL5C');  {'E - Encaminhar carta'}
            MenuAdiciona ('CTAJFL5D');  {'CTRL+E - Encaminhar em anexo'}
        end;
    if folheiaRecebidas then
        begin
            MenuAdiciona ('CTAJFL09');   {'S - selecionar o nome do remetente associando-o a um apelido'}
            MenuAdiciona ('CTAJFL05');  {'U - Preparar resposta automtica'}
        end
    else
        begin
            if not folheiaTransmitidas then
                menuAdiciona ('CTAJFL5F');  {'E - editar carta'}
            MenuAdiciona ('CTAJFL9A');  {'S - selecionar o nome do destinatrio associando-o a um apelido'}
        end;
    MenuAdiciona ('CTAJFL04');  {'A - apagar a carta'}
    MenuAdiciona ('CTAJFL03');  {'I - para obter informaes sobre a carta'}
    MenuAdiciona ('CTAJFL06');  {'C - copiar'}
    MenuAdiciona ('CTAJFL08');  {'T - transmitir cartas j digitadas'}
    if folheiaTransmitidas then
        MenuAdiciona ('CTAJFL8A');  {'R - reenviar carta'}
    MenuAdiciona ('CTAJFL12');  {'O - editar o texto original da carta'}
    MenuAdiciona ('CTAJFL13');  {'Q - Informar qual a carta do total'}
    MenuAdiciona ('CTAJFL29');  {'CTRL+Q - Informar quantas cartas selecionadas do total'}
    MenuAdiciona ('CTAJFL15');  {'D - Informa o tamanho da carta'}
    MenuAdiciona ('CTAJFL28');  {'CTRL+D - Informa o tamanho de todas as cartas'}
    MenuAdiciona ('CTAJFL16');  {'N - Informa o nome do arquivo da carta'}
    MenuAdiciona ('CTAJFL20');  {'G - Busca carta pelo nome do arquivo'}
    MenuAdiciona ('CTAJFL17');  {'CTRL + N - Informa o nmero da carta'}
    MenuAdiciona ('CTAJFL19');  {'CTRL + G - Busca carta pelo nmero'}
    if folheiaRecebidas then
        begin
            MenuAdiciona ('CTAJFL18'); {'M - Marca ou desmarca a carta'}
            MenuAdiciona ('CTAJFL25'); {'CTRL+T - Marca ou desmarca todas as cartas'}
        end;
    MenuAdiciona ('CTAJFL24');  {'B - Editar apelidos'}
    MenuAdiciona ('CTAJFL26');  {'F - Fala o remetente da carta'}
    MenuAdiciona ('CTAJFL27');  {'CTRL+F - Fala o destinatrio da carta'}
    MenuAdiciona ('CTAJFL31');  {'V - Vai para outro folheamento'}
    if folheiaRecebidas then
        begin
            MenuAdiciona ('CTAJFL11');  {'CTRL + L - Liberar o remetente no MataSpam'}
            MenuAdiciona ('CTAJFL14');  {'CTRL + B - Bloquear o remetente no MataSpam'}
        end;
    MenuAdiciona ('CTAJFL32');  {'F3 - Ordenar'}
    MenuAdiciona ('CTAJFL10');  {'F5 - procurar'}
    MenuAdiciona ('CTAJFL30');  {'F6 - procura invertida'}
    MenuAdiciona ('CTAJFL07');  {'ESC terminar folheamento'}

    n := popupMenuSeleciona;

    if (n > 0) and (n <= nOpc) then
        if n in [(Nopc-4) .. (Nopc-2)] then
            begin
                selSetasFolheia := #0;
                if folheiaRecebidas then c := tabLRec [n]
                else
                if folheiaTransmitidas then c := tabLTra [n]
                else c := tabLPre [n];
            end
        else
            if folheiaRecebidas then selSetasFolheia := tabLRec [n]
            else
            if folheiaTransmitidas then selSetasFolheia := tabLTra [n]
            else selSetasFolheia := tabLPre [n]
    else
        begin
            selSetasFolheia := #0;
            c := f12;
        end;
end;

{--------------------------------------------------------}
{   Folheia e responde cartas
{   TipoFolheamento:
{       F - todas Recebidas
{       L - recebidas Lidas
{       N - recebidas No lidas
{       T Transmitidas
{       P Preparadas
{       CONTROL + <tipo folheamento>, mostram somente a da conta atual, no
{       caso de vrias contas no mesmo diretrio.
{--------------------------------------------------------}

procedure inicializaFolheamento;
var
    i: integer;
    s: string;
begin
    folheiaCria (1, 3, 80, 17);
    for i :=  1 to numRegs do
        begin
            s := '';
            folheiaAdicionaEspecial (s, regLido [i]^.selecionado, s);
        end;
end;

{-------------------------------------------------------------}
{  Preenche item com as informaes da carta, se ainda vazio
{-------------------------------------------------------------}

procedure preencheItemOnline (nItem: integer; var conteudo, fala: string;
                              var selec: boolean);
var
    i: integer;
    s, s2: string;
begin
    if (conteudo <> '') or (fala <> '') then exit;
    folheiaObtemItem (nItem, s, regLido[nItem]^.selecionado);

    carregaArqPreencheCabPrin (nItem);

    if folheiaRecebidas then
        s := regLido [nItem]^.carta^.from
    else
        s := regLido [nItem]^.carta^.to_;

    i := pos ('<', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';

    s2 := regLido [nItem]^.carta^.subject;
    s2 := pegaPrefixoAssunto(s2) + limpaAssunto(s2);
    deletaAspas (s2);
    if s2 = '' then s2:= 'NULO';

    conteudo := copy (s+BRANCOS, 1, 30) +  copy (s2+BRANCOS, 1, 50);
    if FALANOMEPRIMEIRO then
        fala := s + ' ' + s2
    else
        fala := s2 + ' ' + s;
    selec := regLido [nItem]^.selecionado;
end;

{-------------------------------------------------------------}
{       Troca de folheamento
{-------------------------------------------------------------}

function trocaDeFolheamento (dirAtual: string; pastaRegra: string = ''): boolean;
var c: char;
begin
    repeat
        msgBaixo ('CTQUAFOL'); {'Qual o tipo de folheamento? (F/N/L/P/T)'}
        c := upcase (readkey);
    until c in ['F', 'N', 'L', 'P', 'T', ^F, ^N, ^L, ^P, ^T, ENTER, ESC];

    if c in [ENTER, ESC] then
        begin
            trocaDeFolheamento := false;
            msgBaixo ('CTDESIST'); {'Desistiu'}
        end
    else
        begin
            trocaDeFolheamento := true;
            folheiaDestroi;
            desmontaListaDeCartas;
            {$I-}  chdir (dirAtual);  {$I+}
            if ioresult <> 0 then;
            folhearCartas (c, pastaRegra);
        end;
end;

{--------------------------------------------------------}
{                    folheamento
{--------------------------------------------------------}

procedure folhearCartas (tipoFolheamento: char; pastaRegra: string = '');
var
    c, c2: char;
    nCar, i: integer;
    dirAtualCartas, extensao, s: string;
    podeFalar, aux: boolean;

label procurarAchou;

begin
    if not agruparPorAssunto then
    case tipoFolheamento of
        'F', ^F: msgBaixo ('CTRECEBI'); {'Recebidas'}
        'N', ^N: msgBaixo ('CTNAOLID'); {'No lidas'}
        'L', ^l: msgBaixo ('CTLIDAS'); {'Lidas'}
        'P', ^P: msgBaixo ('CTPREPAR'); {'Preparadas'}
        'T', ^T: msgBaixo ('CTTRANSM'); {'Transmitidas'}
    end;

    tipoFolheGlobal := tipoFolheamento;
    getDir (0, dirAtual);

    case tipoFolheamento of
        'F', 'L', 'N', ^F, ^L, ^N: begin
                            folheiaRecebidas := true;
                            folheiaTransmitidas := false;
                            extensao := 'CAR';
                            {$I-}  chdir (dirRecebe);  {$I+}
                            if ioresult <> 0 then ;
                       end;
        'P', ^P: begin
                folheiaRecebidas := false;
                folheiaTransmitidas := false;
                extensao := 'CPR';
                {$I-}  chdir (dirEnvia);  {$I+}
                if ioresult <> 0 then ;
             end;
        'T', ^T: begin
                folheiaRecebidas := false;
                folheiaTransmitidas := true;
                extensao := 'ENV';
                {$I-}  chdir (dirEnvia);  {$I+}
                if ioresult <> 0 then ;
             end;
    end;

    if pastaRegra <> '' then
        begin
            getDir (0, dirAtualCartas);
            dirRecebe := pastaRegra;
            {$I-}  chdir (dirRecebe);  {$I+}
            if ioresult <> 0 then ;

        end;

    montaListaDeCartas (extensao, tipoFolheamento);
    if numRegs = 0 then
        begin
            msgBaixo ('CTSEMCAR');  {'No tem carta neste diretrio'}
            agruparPorAssunto := false;
            if pastaRegra <> '' then dirRecebe := dirAtualCartas;
            exit;
        end;

    if ordenarDataEnvio or agruparPorAssunto then
        ordenarLista ('date', not agruparPorAssunto)
    else
        ordenarLista ('datahora', true);

    if agruparPorAssunto then
        procurarNaCarta (true, 1);

procurarAchou:
    telaFolheamentoCartas;
    if not agruparPorAssunto then
        begin
            falaNumeroCartas;
            mensagem ('CTUSESET', -1);  {'Folheando: use as setas, depois tecle sua opo'}
        end
    else
        sintetiza (intToStr(numRegs));

    nCar := 1;
    podeFalar := true;
    repeat
        telaFolheamentoCartas;
        inicializaFolheamento;
        folheiaCorDoMeio (1, 30, CYAN);

        FolheiaPreencheItemOnline := @preencheItemOnline;
        folheiaExecuta (nCar, nCar, c, c2, podeFalar);
        FolheiaPreencheItemOnline := NIL;

        if nCar < 1 then nCar := 1;
        if nCar > numRegs then nCar := numRegs;
        sintPara;
        for i := 1 to numRegs do
            folheiaObtemItem (i, s, regLido[i]^.selecionado);

        gotoxy (1, 19);
        if c2 = F9 then
            c := selSetasFolheia (c2);

        if c = #0 then
            begin
                case c2 of
                    ESQ: begin
                            s := regLido [nCar]^.carta^.subject;
                            s := pegaPrefixoAssunto(s) + limpaAssunto(s);
                            if trim(s) = '' then
                                s := 'Nulo';
                            sintetiza (s);
                            contemAnexos (nCar);
                         end;
                    DIR: sintetiza (regLido [nCar]^.carta^.from);
                    F1:    ajudaFolheia;
                    F3:  begin
                                folheiaDestroi;
                                escolheOrdenacao;
                                goto procurarAchou;
                         end;
                    F5, f6:  begin
                                folheiaDestroi;
                                aux := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procurarNaCarta (c2 = F5, nCar);
                                agruparPorAssunto := aux;
                                goto procurarAchou;
                         end;
                    F7: nCar := removerCarta (nCar, true, false);
                    F8:     falaHora;
                    CTLF8:   falaDia;
                    F12: begin {No faz nada, continua folheando}
                            textBackGround (MAGENTA);
                            msgBaixo ('CTCNTFOL');  {'Continue folheando ou tecle ESC'}
                            textBackGround (BLACK);
                            writeln;
                         end;
                end;
            end
        else
            begin
                c := upcase (c);
                case c of
                    'I': infoCarta (nCar);
                    ^I:   begin
                             sintSoletra (nomeConfiguracao);
                             delay (200);
                          end;
                    'B': editarApelidos;
                    'N': sintetiza (regLido [nCar]^.carta^.nomArqCarta);
                    ^N : sintetiza (intToStr (nCar));
                    'M', ^T: if (folheiaRecebidas) and (c = 'M') then
                                  marcaOuDesmarca(nCar, false, nbaseRecebe)
                             else
                             if folheiaRecebidas then
                                  marcaOuDesmarca(0, false, nbaseRecebe)
                             else
                                  msgBaixo ('CTOPVINV'); {'Opo invlida, aperte F1 para ajuda'}
                    'D': tamanhoCarta (nCar);
                    ^D : tamanhoTodasCartas;
                    ENTER, 'L', CTLENTER:
                         begin
                             folheiaDestroi;
                             leCarta (nCar, not (c in [CTLENTER, ^L]));
                             if (folheiaRecebidas) and
                                (pos ('M.', regLido[nCar]^.carta^.nomArqCarta) = 0) then
                                     marcaOuDesmarca(nCar, true, nbaseRecebe);
                             limpaBufTec;
                         end;
                    'P':
                        begin
                            folheiaDestroi;
                            if carregaLinhasArquivo (regLido[ncar]^.carta^.nomArqCarta) then//Aloca o arquivo da carta
                                begin
                                    preencheCartaPrincipal (regLido[ncar]);//preenche o cabealho principal da carta
                                    destroiLinhasArquivo;//Desaloca o arquivo da carta
                                end;
                            mostraItensCarta ( regLido[nCar]);
                        end;
                    'A', ^A: nCar := removerCarta (nCar, (c = 'A'), false);
                    'R', 'E': if folheiaRecebidas or (folheiaTransmitidas  and (c = 'E')) then
                            begin
                                folheiaDestroi;
                                prepararCarta (c, nCar, false, '');
                            end
                         else
                         if (folheiaTransmitidas) and (c = 'R') then
                            reenviarCarta (nCar)
                         else
                         if  (not folheiaTransmitidas) and (c = 'E') then
                            begin
                                folheiaDestroi;
                                prepararCarta ('E', nCar, true, '');
                            end
                         else
                            msgBaixo ('CTOPVINV'); {'Opo invlida, aperte F1 para ajuda'}
                    ^R, ^E: if folheiaRecebidas  or (folheiaTransmitidas  and (c = ^E)) then
                            begin
                                folheiaDestroi;
                                prepararCarta (c, nCar, false, '');
                            end
                         else msgBaixo ('CTOPVINV'); {'Opo invlida, aperte F1 para ajuda'}
                    'F': sintetiza (regLido [nCar]^.carta^.from);
                    ^F: if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
                            sintetiza (regLido [nCar]^.carta^.delivered_to)
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                            sintetiza (regLido [nCar]^.carta^.to_)
                        else
                            sintetiza (regLido [nCar]^.carta^.bcc);
                    'C': begin
                            nCar := fazCopias (nCar, dirAtual);
                            limpaBufTec;
                            if nCar > numRegs then nCar := numRegs;
                         end;
                    'S': selecionaApelido (nCar);
                    ^B: if folheiaRecebidas then
                             adicionaNoMataSpam (nCar, true)
                         else
                             msgBaixo ('CTOPVINV'); {'Opo invlida, aperte F1 para ajuda'}
                    ^L: if folheiaRecebidas then
                             adicionaNoMataSpam (nCar, false)
                         else
                             msgBaixo ('CTOPVINV');  {'Opo invlida, aperte F1 para ajuda'}
                    ^S: for i := 1 to numRegs do
                            regLido [i]^.selecionado := true;

                    'O':
                        begin
                            editaArquivo (regLido [nCar]^.carta^.nomarqCarta);
                            regLido [nCar]^.carta^.preenchido := false;
                            carregaArqPreencheCabPrin (nCar);
                            limpabuftec;
                        end;
                    'T': if tipoFolheamento in ['P', ^P] then
                                begin
                                    transmitirCartas (true, tipoFolheamento);
                                    folheiaDestroi;
                                    desmontaListaDeCartas;
                                    {$I-}  chdir (dirAtual);  {$I+}
                                    if ioresult <> 0 then;
                                    folhearCartas (tipoFolheamento);
                                    exit;
                                end
                          else
                                transmitirCartas (false, 'P');

                    'Q', ^Q: falaQualItemDeQuantos (nCar, c = ^Q);
                    'G': nCar := posicaoNomeArqCarta (nCar);
                    ^G: nCar := posicaoCarta (nCar);
                    'V': begin
                            agruparPorAssunto := false;
                            if trocaDeFolheamento (dirAtual, pastaRegra) then
                                begin
                                    if pastaRegra <> '' then
                                        dirRecebe := dirAtualCartas;
                                    exit;
                                end;
                         end;

                    ^P: begin
                            agruparPorAssunto := false;
                            c := ESC;
                        end;
                    'U': if folheiaRecebidas then ativaRespAut (true, false, nCar);
                    ESC: if perguntaAoSairFolheamento then
                        repeat
                            msgBaixo('CTSAIFOL'); {'Deseja sair do folheamento?'}
                            sintLeTecla (c, c2);
                            if upcase(c) in ['S', ENTER] then c := ESC
                            else
                                begin
                                    msgBaixo('CTDESIST'); {'Desistiu'}
                                    c := 'N';
                                    msgBaixo ('CTCNTFOL');  {'Continue folheando ou tecle ESC'}
                                end;
                        until upcase(c) in ['S', 'N', ENTER, ESC];

                else
                    if c <> ESC then msgBaixo ('CTOPVINV'); {'Opo invlida, aperte F1 para ajuda'}
                end;

                if (numRegs >0) and (c <> ESC) and
                    (upcase(c) in ['I', 'B', ENTER, 'L', CTLENTER, 'P', 'A', ^A,
                    'R', ^R, 'E', ^E, 'C', 'S', 'O', 'T', 'U']) then
                    msgBaixo ('CTCNTFOL');  {'Continue folheando ou tecle ESC'}

            end;

        if numRegs <= 0 then
            begin
                if (not agruparPorAssunto) and
                    not ((tipoFolheamento in ['P', ^P]) and (numRegs=0)) then
                    msgBaixo ('CTSEMCAR');  {'No tem carta neste diretrio'}
                c := ESC;
            end;
        if (upCase(c) in['N', ^N, 'D', ^D, 'F', ^F, 'Q', ^Q,
            'I', 'B', ENTER, 'L', CTLENTER, 'P', 'A', ^A, 'R', ^R, 'E', ^E, 'C',
            'S', 'O', 'T', 'U']) or
            (c2 in [ESQ, DIR, f8, CTLF8]) then
            podeFalar := false
        else
            podeFalar := true;

        if not (upcase (c) in ['L', ENTER, CTLENTER, 'P', 'R', ^R, 'E', ^E]) then
            folheiaDestroi;

    until c = #$1b;
    if (numRegs > 0) and (not agruparPorAssunto) then
        msgBaixo ('CTFOLFIM');  {'Folheamento terminado'}
    desmontaListaDeCartas;
    {$I-}  chdir (dirAtual);  {$I+}
    if ioresult <> 0 then;

    if agruparPorAssunto then folhearCartas (tipoFolheamento, pastaRegra);
    if pastaRegra <> '' then dirRecebe := dirAtualCartas;
end;

end.
