{-------------------------------------------------------------}
{
{           CartaVox - Monitora correio
{
{-------------------------------------------------------------}

unit carMonit;

interface

uses
    dvcrt,
    dvWin,
    sysUtils,
    windows,
    careMudo,
    carMsg,
    carPop3,
    carRede,
    winSock,    //Declarar depois de carRede
    carUtil,
    carVars,
    carEnvia,
    carSMTP,
    carConf,
    classes;

procedure monitorarCorreio;
procedure monitorarRespAut;
procedure monitorarCorreioGrupoContas(listaGrupo: TStringList);

implementation

var
    chegAntes: integer;
    avisaSempre: boolean;

{-------------------------------------------------------------}
{       envia conta e senha para POP3 e ve quantas cartas
{-------------------------------------------------------------}

function verificaPOP3 (hostPOP3: string; portaPOP3: integer;
                       conta, senha: string; respAut: boolean): integer;
    { j prevendo futuramente monitorao de vrias contas }
var
    i, lidos: integer;
    s: string;
    numCartas: integer;

label erro;

    function sendRec (s: string): string;
    begin
        StrPCopy (bufEnvia, s + CRLF);
        sendBuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
        netDebug (bufEnvia, strlen (bufEnvia));

        lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
        bufRecebe [lidos] := #$0;
        netDebug (bufRecebe, lidos);

        if lidos = 0 then
            sendRec := '-'
        else
            sendRec := strPas (bufRecebe);
    end;

begin
    numCartas := -1;

    sockPOP3 := carrede.abreConexao (hostPOP3, portaPOP3, true);
    if sockPOP3 = -1 then
        begin
            senhaSalva := '';
            goto erro;
        end;

    if usaSSL then
        if not ativaSSL(sockPOP3) then
            begin
                mensagem ('CTSSLNAO', 2);   {'Segurana SSL no pode ser ativada'}
                fechaConexao (sockPOP3);
                goto erro;
            end;

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if (lidos <= 0) then
        begin
            senhaSalva := '';
            goto erro;
        end;
    bufRecebe [lidos] := #$0;
    netDebug (bufRecebe, lidos);

    s := sendRec ('USER '+ contaUsuario);
    if s[1] <> '+' then
        begin
            senhaSalva := '';
            goto erro;
        end;
    s := sendRec ('PASS '+ senha);
    if s[1] <> '+' then
        begin
            senhaSalva := '';
            mensagem ('CTERRSEN', 1);    {'Senha est errada'}
            goto erro;
        end;

    numCartas := 0;

    s := sendRec ('STAT');
    if s[1] <> '+' then
        begin
            senhaSalva := '';
            goto erro;
        end;

    s := s + ' 0 0 ';   {sentinela}
    i := 1;
    while not (s[i] in ['0'..'9']) do i := i + 1;
    numCartasPOP3 := 0;
    while s[i] in ['0'..'9'] do
        begin
            numCartas := (numCartas * 10) + (ord(s[i]) - ord ('0'));
            i := i + 1;
        end;

    if (numCartas <> 0) and (respAut = false) then
        begin
            if (numCartas > chegAntes) or avisaSempre then
                begin
                    sintSom ('CTPLIM');
                    if nomeConfiguracao <> '' then
                        sintWriteln (nomeConfiguracao);
                end;
            chegAntes := numCartas;
        end;

erro:
    if sockPOP3 <> -1 then
        fechaConexao (sockPOP3);
    verificaPop3 := numCartas;
end;

{-------------------------------------------------------------}
{       Monitorao da resposta automtica
{-------------------------------------------------------------}

procedure monitorarRespAut;
var
    salvaAttr: word;
    senha: string;
    i, cartasExistentes: integer;
    c: char;
    chegadas, cartasRecebidas, totalCartas: integer;
    primeiraPassagem: boolean;

label fim;
begin
    if trim (senhaSalva) = '' then
        begin
    senha := '';
    salvaAttr := textattr;
            textBackground (RED);
            mensagem ('CTINFSEN', 1);  {'Informe sua senha'}
            textBackground (BLACK);
            textColor (BLACK);
            c := sintEditaCampoMudo (senha, 1, wherey, 255, 80, true);
            writeln;
            textAttr := salvaAttr;
            if trim (senha) <> '' then senhaSalva := senha;
            if (c = ESC) or (trim(senhaSalva) = '') then goto fim;
        end;

    cartasExistentes := verificaPop3 (hostPOP3, portaPOP3, contaUsuario, senhaSalva, true);
    if cartasExistentes = -1 then
        begin
             msgBaixo ('CTCONCAN');  {'Conexao com servidor foi cancelada'}
             senhaSalva := '';
             exit;
        end;
    mensagem ('CTREAUFE', 1); {'Resposta automtica de frias ativada'}
    primeiraPassagem := true;
    avisaSempre := false;

    setWindowTitle ('CARTAVOX ' + nomeConfiguracao + ' (Resposta automtica)');
    chegAntes := 0;
    totalCartas := 0;
    c := ' ';
    repeat
        chegadas := verificaPop3 (hostPOP3, portaPOP3, contaUsuario, senhaSalva, true);
        if chegadas = -1 then
            senhaSalva := ''
        else
            for i := 1 to 120 do
                begin
                    delay (500);
                    if keypressed then
                         begin
                             c := readkey;
                             if c = ESC then break;
                         end;
                end;

        if (chegadas > cartasExistentes) then
            begin
                cartasRecebidas := receberCartasRespAut (primeiraPassagem, cartasExistentes, chegadas);
                if primeiraPassagem = true then
                    primeiraPassagem := false;
                if cartasRecebidas = -1 then chegadas := -1
                else if cartasRecebidas > 0 then
                    begin
                       prepararCartaRespAut (cartasRecebidas, true);
                       transmitirCartasRespAut;
                       totalCartas := totalCartas + cartasRecebidas;
                    end;
                setWindowTitle (pegaTextoMensagem('CTRECEBI'{'Recebidas'})+
                    ' ' + intToStr(totalCartas) + ' - CARTAVOX ' +
                    nomeConfiguracao + ' (Resposta Automtica) ');
            end;

    until (chegadas = -1) or (c = ESC);

    while keypressed do readkey;
    setWindowTitle ('CARTAVOX ' + nomeConfiguracao);
    mensagem ('CTOK', 1); {'OK'}
    exit;

fim:
    mensagem ('CTDESIST', 1); {'Desistiu'}
    writeln;
end;

{-------------------------------------------------------------}
{       Monitorao do grupo de contas
{-------------------------------------------------------------}

procedure monitorarCorreioGrupoContas(listaGrupo: TStringList);
var
    aux, contaAtual: string;
    i, indice, iVet, tot, cod: integer;
    c, c2: char;
    seg: integer;
    chegadas, jaRecebidas: integer;
    receberAutomaticamente, entrouRecebe: boolean;
    vetNumChegadas : Array[0..1000] of integer;

label fim;
begin
    repeat
        mensagem ('CTINTERV', 1);   {'Aps quantos segundos remonitoro (sugiro 60)? ' }
        c := sintEditaCampo (aux, 1, wherey, 255, 80, true);
        if verificaStringNumero(aux) = false then
            begin
                c := ' ';
                aux := '';
            end;
        writeln;
    until upcase (c) in [ENTER, ESC];

    if c = ESC then goto fim;
    if trim (aux) = '' then seg := 0
    else seg := strToInt (aux);
    if seg <= 0 then seg := 60
    else
    if seg < 15 then seg := 15;

    repeat
        mensagem ('CTAVINOV', 0);   {'Aviso s quando chegarem cartas novas? '}
        sintLeTecla (c, c2);
        writeln;
    until upcase (c) in ['S', 'N', ENTER, ESC];
    if c = ESC then goto fim;
    avisaSempre := not (upcase (c) in ['S', ENTER]);

    repeat
        mensagem ('CTRECAUT', 0);   {'Deseja receber as cartas automaticamente: '}
        sintLeTecla (c, c2);
        writeln;
    until upcase (c) in ['S', 'N', ENTER, ESC];
    if c = ESC then goto fim;
    receberAutomaticamente := upcase (c) in ['S', ENTER];

    entrouRecebe := false;
    cod := 0;
    chegAntes := 0;
    jaRecebidas := 0;
    indice := 0;
    c := ' ';
    repeat

        if  indice <= listaGrupo.Count - 1 then
            contaAtual := listaGrupo.Strings[indice]
        else
            begin
                for i := 1 to seg * 2 do
                    begin
                        delay (500);
                        if keypressed then
                            begin
                                c := readkey;
                                if receberAutomaticamente and (jaRecebidas > 0) then
                                    begin
                                        mensagem ('CTRECEBI', 0);  {'Recebidas'}
                                        write (': ');
                                        sintWriteint (jaRecebidas);
                                        writeln;
                                    end
                                else
                                    begin
                                        tot := 0;
                                        for iVet:=0 to 999 do
                                            tot := tot + vetNumChegadas[iVet];
                                        mensagem ('CTDISPON', 0);  {'Cartas disponveis: '}
                                        sintWriteint (tot);
                                        writeln;
                                    end;
                                if c = ESC then break;
                            end;
                    end;
                indice := 0;
                contaAtual := listaGrupo.Strings[indice];
            end;
        recuperaConfigGrupoContas (contaAtual);

        if receberAutomaticamente then
            setWindowTitle (pegaTextoMensagem('CTRECEBI'{'Recebidas'})+': ' + intToStr(jaRecebidas) + ' - Cartavox monitorando grupo de contas')
        else
            begin
                tot := 0;
                for iVet:=0 to 999 do tot := tot + vetNumChegadas[iVet];
                setWindowTitle ('Cartas disponveis: ' + intToStr(tot) + ' - Cartavox monitorando grupo de contas');
            end;

        chegadas := verificaPop3 (hostPOP3, portaPOP3, contaUsuario, senhaSalva, true);

        if receberAutomaticamente then
            begin
                if chegadas > 0 then
                    begin
                        sintSom ('CTPLIM');
                        if nomeConfiguracao <> '' then
                            sintWriteln (nomeConfiguracao);
                    end;
            end
        else
           begin
               if chegadas > 0 then
                   begin
                       if avisaSempre then
                           begin
                               sintSom ('CTPLIM');
                               if nomeConfiguracao <> '' then
                                   sintWriteln (nomeConfiguracao);
                               vetNumChegadas[indice] := chegadas;
                           end
                       else
                           begin
                               if chegadas > vetNumChegadas[indice] then
                                   begin
                                       sintSom ('CTPLIM');
                                       if nomeConfiguracao <> '' then
                                           sintWriteln
(nomeConfiguracao);
                                       vetNumChegadas[indice] := chegadas;
                                   end;
                           end;
                   end;
           end;

        if chegadas = -1 then break
        else if (chegadas > 0) and receberAutomaticamente then
            begin
                sintSom ('CTPLIM');
                sintWriteln (nomeConfiguracao);
                cod := receberCartasGrupoContas (true);
                if cod = -1 then break;
                jaRecebidas := jaRecebidas + chegadas;
            end;

        indice := indice + 1;

    until (chegadas = -1) or (c = ESC);

    if receberAutomaticamente = false then
        for indice:=0 to listaGrupo.Count-1 do
            begin
                contaAtual := listaGrupo.Strings[indice];
                recuperaConfigGrupoContas (contaAtual);
                chegadas := verificaPop3 (hostPOP3, portaPOP3, contaUsuario, senhaSalva, true);
                if chegadas > 0 then
                    begin
                        writeln;
                        cod := receberCartasGrupoContas (false);
                        if cod = -1 then break;
                        entrouRecebe := true;
                    end
            end;

    while keypressed do readkey;
    if (entrouRecebe = false) and (cod <> -1) then mensagem ('CTOK', 1); {'OK'}
    writeln;
    exit;

fim:
    mensagem ('CTDESIST', 1); {'Desistiu'}
    writeln;
end;

{-------------------------------------------------------------}
{       Monitorao da conta atual
{-------------------------------------------------------------}

procedure monitorarCorreio;
var
    salvaAttr: word;
    senha: string;
    i: integer;
    c: char;
    seg: integer;
    chegadas, jaRecebidas: integer;
    receberAutomaticamente: boolean;

label fim;
begin
    if trim (senhaSalva) = '' then
        begin
    senha := '';
    salvaAttr := textattr;
            textBackground (RED);
            mensagem ('CTINFSEN', 1);  {'Informe sua senha'}
            textBackground (BLACK);
            textColor (BLACK);
            c := sintEditaCampoMudo (senha, 1, wherey, 255, 80, true);
            writeln;
            textAttr := salvaAttr;
            if trim (senha) <> '' then senhaSalva := senha;
            if (c = ESC) or (trim(senhaSalva) = '') then goto fim;
        end;

//neno    mensagem ('CTINTERV', 0);   {'Aps quantos segundos remonitoro (sugiro 60)? ' }
//    c := sintEditaCampo (aux, 1, wherey, 255, 80, true);
//    writeln;
//    if c = ESC then goto fim;
//    if trim (aux) = '' then seg := 0
//    else seg := strToInt (aux);
//    if seg <= 0 then seg := 60
//    else
//    if seg < 15 then
seg := tempoReMonitorar;// 15;

//    mensagem ('CTAVINOV', 0);   {'Aviso s quando chegarem cartas novas? '}
//    c := sintreadkey;
//    if c = ESC then goto fim;
    avisaSempre := avisaNovasMonitorar;//neno not (upcase (c) in ['S', ENTER]);
//    writeln;

//Neno    mensagem ('CTRECAUT', 0);   {'Deseja receber as cartas automaticamente: '}
//    c := sintreadkey;
//    if c = ESC then goto fim;
    receberAutomaticamente := receberaAutMonitorar;// true;// upcase (c) in ['S', ENTER];

    setWindowTitle ('CARTAVOX ' + nomeConfiguracao + ' (MONITORANDO)');
    chegAntes := 0;
    jaRecebidas := 0;
    c := ' ';
    repeat
        chegadas := verificaPop3 (hostPOP3, portaPOP3, contaUsuario, senhaSalva, false);
        if chegadas > 0 then
            setWindowTitle (pegaTextoMensagem('CTDISPON') + ' ' + intToStr(chegadas) + ' - CARTAVOX ' + nomeConfiguracao + ' (MONITORANDO)'); {Cartas disponveis: 
'}
        if chegadas = -1 then
            begin
                mensagem ('CTERCONX', 1);    {'Erro na conexo com o correio'}
                senhaSalva := '';
            end
        else
            for i := 1 to seg * 2 do
                begin
                    delay (500);
                    if keypressed then
                         begin
                             c := readkey;
                             if receberAutomaticamente and (jaRecebidas > 0) then
                                 begin
                                     mensagem ('CTRECEBI', 0); {'Recebidas'}
                                     write (': ');
                                     sintWriteint (jaRecebidas);
                                     writeln;
                                 end
                             else
                                 begin
                                     mensagem ('CTDISPON', 0);   {'Cartas disponveis: '}
                                     sintWriteint (chegadas);
                                     writeln;
                                 end;
                             if c = ESC then break;
                         end;
                end;

        if (chegadas > 0) and receberAutomaticamente then
            begin
                sintSom ('CTPLIM');
                sintWriteln (nomeConfiguracao);
                receberCartas (true);
                jaRecebidas := jaRecebidas + chegadas;
                setWindowTitle (pegaTextoMensagem('CTRECEBI')+' ' + intToStr(jaRecebidas) + ' - CARTAVOX ' + nomeConfiguracao + ' (MONITORANDO) '); {'Recebidas'}
            end;

    until (chegadas = -1) or (c = ESC);

    setWindowTitle ('CARTAVOX ' + nomeConfiguracao);
//NenoNeno    if chegadas > 0 then
    if (chegadas > 0) and receberAutomaticamente then
        begin
            writeln;
            receberCartas (true);
        end
    else
        mensagem ('CTOK', 1); {'OK'}
    writeln;
    exit;

fim:
    mensagem ('CTDESIST', 1); {'Desistiu'}
    writeln;
end;

{-------------------------------------------------------------}
begin
end.
