{-------------------------------------------------------------}
{
{       Programa de correio, cliente SMTP e POP3
{
{       Autor: Jose' Antonio Borges
{       Em 10 de abril de 1998
{
{       Atualizado por: Neno Henrique da Cunha Albernaz
{       De 2002 a 2008
{
{-------------------------------------------------------------}

{-------------------------------------------------------------}
{       arquivos de inclusao obrigatoria
{-------------------------------------------------------------}

program Cartavox;
uses
    dvcrt,
    dvform,
    dvhora,
    dvWin,
    sysutils,
    windows,
    carApeli,
    carConf,
    carDecod,
    carEnvia,
    carFolhe,
    carList,
    carMonit,
    carMsg,
    carPop3,
    carRede,
    carSMTP,
    carTela,
    carUtil,
    carVars,
    carRegras,
    carResp,
    carFolInt,
    carSpam,
    carIMAP,
    carCont;

{-------------------------------------------------------------}
{       rotina de inicializacao
{-------------------------------------------------------------}

procedure inicializa;
begin
    randomize;
    debug := false;
    sintInic (0, sintambiente ('CARTAVOX', 'DIRCARTAVOX'));

    clrscr;
    limpaBufTec;
    textBACKGROUND (BLUE);
    mensagem ('CTINIC', 0);  {'CARTAVOX - Correio Eletrnico - NCE/UFRJ - v.'}
    writeln (VERSAO);
    sintetiza (VERSAO);
    textBackground (BLACK);
    writeln;

    while sintFalando do waitMessage;  // controle das paradas de fala
    if not keypressed then delay(5);
    pegaConfigInicial;

    if (hostSMTP = '') or (hostPOP3 = '') or (enderUsuario = '') or (contaUsuario = '') or
       (dirRecebe = '') or (dirEnvia = '') then
            configurar;

    nbaseEnvia  := 0;
    nbaseRecebe := 0;
    nbaseCopia  := 0;
    pCC  := NIL;
    pBCC := NIL;

    abreRede;

    if paramCount >= 1 then
        prepararCarta ('P', 0, false, paramStr(1));
end;

{-------------------------------------------------------------}
{       ajuda
{-------------------------------------------------------------}

procedure ajuda;
begin
    telaPrincipal;
    mensagem ('CTAJUD01', 1);  {'As opes so'}
    mensagem ('CTAJUD02', 1);  {'  E   enviar carta'}
    mensagem ('CTAJUD03', 1);  {'  T   transmitir cartas escritas'}
    mensagem ('CTAJUD04', 1);  {'  R   receber cartas do correio'}
    mensagem ('CTAJUD05', 1);  {'  F   folhear as cartas j recebidas'}
    mensagem ('CTAJUD06', 1);  {'  C   configurar o programa'}
    mensagem ('CTSETOPC', 1);  {'Use as setas para conhecer outras opes'}

    limpaBufTec;
    sintBip;
end;

{--------------------------------------------------------}
{       seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;
var n: integer;
const
    tabLetrasOpcoes: string [19] = 'etrfnlicvamzqsbujkx';

begin
    telaPrincipal;
    writeln (pegaTextoMensagem ('CTAJUD01'));  {'As opes so'}
    popupMenuCria (wherex, wherey, 50, 19, MAGENTA);
    MenuAdiciona ('CTAJUD02');  {'  E   enviar carta'}
    MenuAdiciona ('CTAJUD03');  {'  T   transmitir cartas escritas'}
    MenuAdiciona ('CTAJUD04');  {'  R   receber cartas do correio'}
    MenuAdiciona ('CTAJUD05');  {'  F   folhear as cartas j recebidas'}
    MenuAdiciona ('CTAJUD5A');  {'  N   Folhear as cartas no lidas'}
    MenuAdiciona ('CTAJUD5B');  {'  L   Folhear as cartas lidas'}
    MenuAdiciona ('CTAJUD5C');  {'  I   Informar configurao atual'}
    MenuAdiciona ('CTAJUD06');  {'  C   configurar o programa'}
    MenuAdiciona ('CTAJUD6A');  {'  V   verificar cartas preparadas ou transmitidas'}
    MenuAdiciona ('CTAJUD07');  {'  A   editar apelidos'}
    MenuAdiciona ('CTAJUD08');  {'  M   monitorar correio'}
    MenuAdiciona ('CTAJUD09');  {'  Z   apagar cartas duplicadas no lidas'}
    MenuAdiciona ('CTAJUD10');  {'  Q   informar total de cartas'}
    MenuAdiciona ('CTAJUD11');  {'  S   mata Spam'}
    MenuAdiciona ('CTAJUD12');  {'  B   Regras'}
    MenuAdiciona ('CTAJUD13');  {'  U   Resposta automtica'}
    MenuAdiciona ('CTAJUD14');  {'  J   Folhear cartas no servidor'}
    MenuAdiciona ('CTAJUD15');  {'  K   Grupo de contas'}
    MenuAdiciona ('CTAJUD16');  {'  X   Conexo com IMAPUtil'}

    n := popupMenuSeleciona;
    if (n > 0) and (n <= 19) then
        selSetasOpcao := tabLetrasOpcoes[n]
    else
        selSetasOpcao := ENTER;
end;

{--------------------------------------------------------}
{       verificar cartas enviadas
{--------------------------------------------------------}

procedure verificarPreparadasOuTransmitidas;
var
    c: char;
begin
    repeat
        telaPrincipal;
        msgBaixo ('CTQUEVER');    {'Verificar preparadas ou transmitidas ? '}
        c := upcase (readkey);
    until c in ['T', 'P', ^T, ^P, ESC];

    if c = esc then
        msgBaixo ('CTDESIST') {'Desistiu'}
    else
        folhearCartas (c);
end;

{-------------------------------------------------------------}
{       Fala nmero de cartas nos folheamentos
{-------------------------------------------------------------}

procedure falaNumeroTotalDeCartas;
var
    i: integer;
    dirVazio: boolean;
begin
    dirVazio := true;
    i := numeroDeCartas ('P');
    if i > 0 then
        begin
            mensagem  ('CTPREPAR', 0); {'Preparadas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartas ('N');
    if i > 0 then
        begin
            mensagem  ('CTNAOLID', 0); {'No lidas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartas ('L');
    if i > 0 then
        begin
            mensagem ('CTLIDAS', 0); {'Lidas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartas ('T');
    if i > 0 then
        begin
            mensagem ('CTTRANSM', 0); {'Transmitidas'}
            sintwriteln ('  ' + intTostr(i));
            dirVazio := false;
        end;
    if dirVazio then
        mensagem ('CTSEMCAR', 1); {'No tem carta neste diretrio'}
    writeln;
end;

{-------------------------------------------------------------}
{       Rotina de saida do Cartavox
{-------------------------------------------------------------}

function terminaPrograma: boolean;
var
    c1, c2: char;
    sair: boolean;
begin
    sair := false;
    telaPrincipal;
    if perguntaAoSair then
        begin
            repeat
                msgBaixo ('CTCONSAI'); {'Confirma saida do Cartavox?'}
                sintletecla (c1, c2);
            until upcase (c1) in ['S', 'N', ENTER, ESC];
            if upcase (c1) in ['S', ENTER] then
                sair := true;
        end
    else
        sair := true;

    if sair then
        sair := not transmitirPreparadas;

    if not sair then
        begin
            msgBaixo ('CTDESIST'); {'Desistiu'}
        telaPrincipal;
        end;

    TerminaPrograma := sair;
end;

{-------------------------------------------------------------}
{                     programa principal
{-------------------------------------------------------------}

var
    c1, c2: char;
    nCarRecebidas: integer;
    processando: boolean;
    sz: array [0..144] of char;
begin
    inicializa;

    processando := true;
    while (processando)  do
        begin
            {$I-}  chdir (dirAtual);  {$I+}
            if ioresult <> 0 then;
            textBackground (BLUE);
            mensagem ('CTQUALOP', 0);  {'Qual sua opo ? '}
            textBackground (BLACK);
            c1 := readkey ;
            c2 := #$0;
            if c1 = #0 then
                 c2 := readkey
            else
                if not (upcase(c1) in ['F', 'N', 'L', ^F, ^N, ^L]) then
                    sintCarac (c1);
            if c1 <> ^G then
                writeln (c1);

            if (c1 = #0) and (c2 in [CIMA, BAIX, F9]) then
                begin
                    c1 := selSetasOpcao;
                    telaPrincipal;
                end;

            if c1 = #0 then
                case c2 of
                    F1: ajuda;
                    F8: falaHora;
                    CTLF8: falaDia;
                end
            else
            case upcase (c1) of
                'E', 'P': prepararCarta ('P', 0, false, '');
                'T':  transmitirCartas (false, 'P');
                'R', ^R: begin
                            nCarRecebidas := receberCartas (c1 = ^R);
                            if c1 = ^R then
                                if nCarRecebidas <= 0 then
                                    mensagem ('CTNAOEXS', 1) {'No existem cartas no servidor.'}
                                else
                                   begin
                                        mensagem ('CTRECEBI', 0); {'Recebidas'}
                                        write (': ');
                                        sintWriteint (nCarRecebidas);
                                        writeln;
                                end;
                            if autoEnviaDuplicadasLixeira then
                                removeCartasDuplicadas (false);
                     end;
                'F', 'N', 'L', ^F, ^N, ^L:  folhearCartas (upcase(c1));
                'G', ^G: begin
                        agruparPorAssunto := true;
                        if c1 = ^G then
                            folhearCartas (^N)
                        else
                            folhearCartas ('N');
                    end;
                'I':  begin
                         delay (50);
                         sintetiza (nomeConfiguracao);
                         delay (200);
                      end;
                ^I:   begin
                         sintSoletra (nomeConfiguracao);
                         delay (200);
                      end;
                'Q': falaNumeroTotalDeCartas;
                'S': mataSpam;
                ^S: begin
                        mataSpam;
                        nCarRecebidas := receberCartas (true);
                        if nCarRecebidas <= 0 then
                            mensagem ('CTNAOEXS', 1) {'No existem cartas no servidor.'}
                        else
                           begin
                                mensagem ('CTRECEBI', 0); {'Recebidas'}
                                write (': ');
                                sintWriteint (nCarRecebidas);
                                writeln;
                           end;
                    end;
                'C':  configurar;
                'A':  editarApelidos;
                'V':  verificarPreparadasOuTransmitidas;
                'M':  monitorarCorreio;
                'D':  begin
                          debug := not debug;
                          if debug then
                              mensagem ('CTMODDEB', 2)   {'Modo debug: cartas no sero apagadas'}
                          else
                              mensagem ('CTMODNOR', 2);  {'Modo normal'}
                          writeln;
                      end;

                'Z': removeCartasDuplicadas (true);
                'B': inicializaRegras;
                'U': respostaAutomatica;
                'J': folhearCartasServidor;
                'K': inicializaGrupoContas;
                'X': chamaIMAPUtil;
                ^Z: receberGrupoContas;
                ^X: transmitirGrupoContas;
                ^C: monitorarGrupoContas;
                ^Q: informarCartasGrupoContas;

                ESC: processando := not terminaPrograma;
                #$0d: telaPrincipal;
            else
                mensagem ('CTOPVINV', 2);  {'Opo invlida, aperte F1 para ajuda'}
            end;
       end;

    if (guardaSenha) and (trim(senhaSalva) <> '') then
        begin
            strPCopy (sz, codFraseMime64 (senhaSalva));
            writePrivateProfileString('CARTAVOX', 'SCCV', sz, 'DOSVOX.INI');
        end;

//NenoNeno
    deletaArquivo(dirRecebe+ '\$.html');
    deletaArquivo(dirEnvia+ '\$.html');
    deletaArquivo(dirRecebe+ '\$.htm');
    deletaArquivo(dirEnvia+ '\$.htm');
    fechaRede;
    msgBaixo ('CTFIM');  {'Fim do Correio'}
    sintFim;
    doneWinCrt;
end.
